searchData={"items":[{"type":"module","title":"GoogleApi.ServiceControl.V1","doc":"API client metadata for GoogleApi.ServiceControl.V1.","ref":"GoogleApi.ServiceControl.V1.html"},{"type":"function","title":"GoogleApi.ServiceControl.V1.discovery_revision/0","doc":"","ref":"GoogleApi.ServiceControl.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Api.Services","doc":"API calls for all endpoints tagged `Services`.","ref":"GoogleApi.ServiceControl.V1.Api.Services.html"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_allocate_quota/4","doc":"Attempts to allocate quota for the specified consumer. It should be called before the operation is executed. This method requires the `servicemanagement.services.quota` permission on the specified service. For more information, see [Cloud IAM](https://cloud.google.com/iam). **NOTE:** The client **must** fail-open on server errors `INTERNAL`, `UNKNOWN`, `DEADLINE_EXCEEDED`, and `UNAVAILABLE`. To ensure system reliability, the server may inject these errors to prohibit any hard dependency on the quota functionality.","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_allocate_quota/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_allocate_quota/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceControl.V1.Connection.t`) - Connection to server\n*   `service_name` (*type:* `String.t`) - Name of the service as specified in the service configuration. For example, `\"pubsub.googleapis.com\"`. See google.api.Service for the definition of a service name.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_allocate_quota/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_allocate_quota/4","doc":"*   `{:ok, %GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_allocate_quota/4-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_check/4","doc":"Checks whether an operation on a service should be allowed to proceed based on the configuration of the service and related policies. It must be called before the operation is executed. If feasible, the client should cache the check results and reuse them for 60 seconds. In case of any server errors, the client should rely on the cached results for much longer time to avoid outage. WARNING: There is general 60s delay for the configuration and policy propagation, therefore callers MUST NOT depend on the `Check` method having the latest policy information. NOTE: the CheckRequest has the size limit (wire-format byte size) of 1MB. This method requires the `servicemanagement.services.check` permission on the specified service. For more information, see [Cloud IAM](https://cloud.google.com/iam).","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_check/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_check/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceControl.V1.Connection.t`) - Connection to server\n*   `service_name` (*type:* `String.t`) - The service name as specified in its service configuration. For example, `\"pubsub.googleapis.com\"`. See [google.api.Service](https://cloud.google.com/service-management/reference/rpc/google.api#google.api.Service) for the definition of a service name.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceControl.V1.Model.CheckRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_check/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_check/4","doc":"*   `{:ok, %GoogleApi.ServiceControl.V1.Model.CheckResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_check/4-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_report/4","doc":"Reports operation results to Google Service Control, such as logs and metrics. It should be called after an operation is completed. If feasible, the client should aggregate reporting data for up to 5 seconds to reduce API traffic. Limiting aggregation to 5 seconds is to reduce data loss during client crashes. Clients should carefully choose the aggregation time window to avoid data loss risk more than 0.01% for business and compliance reasons. NOTE: the ReportRequest has the size limit (wire-format byte size) of 1MB. This method requires the `servicemanagement.services.report` permission on the specified service. For more information, see [Google Cloud IAM](https://cloud.google.com/iam).","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_report/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_report/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceControl.V1.Connection.t`) - Connection to server\n*   `service_name` (*type:* `String.t`) - The service name as specified in its service configuration. For example, `\"pubsub.googleapis.com\"`. See [google.api.Service](https://cloud.google.com/service-management/reference/rpc/google.api#google.api.Service) for the definition of a service name.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceControl.V1.Model.ReportRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_report/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_report/4","doc":"*   `{:ok, %GoogleApi.ServiceControl.V1.Model.ReportResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_report/4-returns"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Connection","doc":"Handle Tesla connections for GoogleApi.ServiceControl.V1.","ref":"GoogleApi.ServiceControl.V1.Connection.html"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.ServiceControl.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.ServiceControl.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.ServiceControl.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceControl.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.ServiceControl.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.ServiceControl.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceControl.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.ServiceControl.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.ServiceControl.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.ServiceControl.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.ServiceControl.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.ServiceControl.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.ServiceControl.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Connection.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AllocateInfo","doc":"*   `unusedArguments` (*type:* `list(String.t)`, *default:* `nil`) - A list of label keys that were unused by the server in processing the request. Thus, for similar requests repeated in a certain future time window, the caller can choose to ignore these labels in the requests to achieve better client-side cache hits and quota aggregation for rate quota. This field is not populated for allocation quota checks.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest","doc":"Request message for the AllocateQuota method.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest","doc":"*   `allocateOperation` (*type:* `GoogleApi.ServiceControl.V1.Model.QuotaOperation.t`, *default:* `nil`) - Operation that describes the quota allocation.\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse","doc":"Response message for the AllocateQuota method.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse","doc":"*   `allocateErrors` (*type:* `list(GoogleApi.ServiceControl.V1.Model.QuotaError.t)`, *default:* `nil`) - Indicates the decision of the allocate.\n*   `allocateInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.AllocateInfo.t`, *default:* `nil`) - WARNING: DO NOT use this field until this warning message is removed.\n*   `operationId` (*type:* `String.t`, *default:* `nil`) - The same operation_id value used in the AllocateQuotaRequest. Used for logging and diagnostics purposes.\n*   `quotaMetrics` (*type:* `list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)`, *default:* `nil`) - Quota metrics to indicate the result of allocation. Depending on the request, one or more of the following metrics will be included: 1. Per quota group or per quota metric incremental usage will be specified using the following delta metric : \"serviceruntime.googleapis.com/api/consumer/quota_used_count\" 2. The quota limit reached condition will be specified using the following boolean metric : \"serviceruntime.googleapis.com/quota/exceeded\"\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - ID of the actual config used to process the request.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AttributeValue","doc":"The allowed types for [VALUE] in a `[KEY]:[VALUE]` attribute.","ref":"GoogleApi.ServiceControl.V1.Model.AttributeValue.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AttributeValue","doc":"*   `boolValue` (*type:* `boolean()`, *default:* `nil`) - A Boolean value represented by `true` or `false`.\n*   `intValue` (*type:* `String.t`, *default:* `nil`) - A 64-bit signed integer.\n*   `stringValue` (*type:* `GoogleApi.ServiceControl.V1.Model.TruncatableString.t`, *default:* `nil`) - A string up to 256 bytes long.","ref":"GoogleApi.ServiceControl.V1.Model.AttributeValue.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AttributeValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AttributeValue.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AttributeValue.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AttributeValue.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Attributes","doc":"A set of attributes, each in the format `[KEY]:[VALUE]`.","ref":"GoogleApi.ServiceControl.V1.Model.Attributes.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Attributes","doc":"*   `attributeMap` (*type:* `%{optional(String.t) => GoogleApi.ServiceControl.V1.Model.AttributeValue.t}`, *default:* `nil`) - The set of attributes. Each attribute's key can be up to 128 bytes long. The value can be a string up to 256 bytes, a signed 64-bit integer, or the Boolean values `true` and `false`. For example: \"/instance_id\": \"my-instance\" \"/http/user_agent\": \"\" \"/http/request_bytes\": 300 \"abc.com/myattribute\": true\n*   `droppedAttributesCount` (*type:* `integer()`, *default:* `nil`) - The number of attributes that were discarded. Attributes can be discarded because their keys are too long or because there are too many attributes. If this value is 0 then all attributes are valid.","ref":"GoogleApi.ServiceControl.V1.Model.Attributes.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Attributes.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Attributes.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Attributes.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Attributes.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AuditLog","doc":"Common audit log format for Google Cloud Platform API operations.","ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AuditLog","doc":"*   `authenticationInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.t`, *default:* `nil`) - Authentication information.\n*   `authorizationInfo` (*type:* `list(GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.t)`, *default:* `nil`) - Authorization information. If there are multiple resources or permissions involved, then there is one AuthorizationInfo element for each {resource, permission} tuple.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Other service-specific data about the request, response, and other information associated with the current audited event.\n*   `methodName` (*type:* `String.t`, *default:* `nil`) - The name of the service method or operation. For API calls, this should be the name of the API method. For example, \"google.cloud.bigquery.v2.TableService.InsertTable\" \"google.logging.v2.ConfigServiceV2.CreateSink\"\n*   `numResponseItems` (*type:* `String.t`, *default:* `nil`) - The number of items returned from a List or Query API method, if applicable.\n*   `policyViolationInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.t`, *default:* `nil`) - Indicates the policy violations for this request. If the request is denied by the policy, violation information will be logged here.\n*   `request` (*type:* `map()`, *default:* `nil`) - The operation request. This may not include all request parameters, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.\n*   `requestMetadata` (*type:* `GoogleApi.ServiceControl.V1.Model.RequestMetadata.t`, *default:* `nil`) - Metadata about the operation.\n*   `resourceLocation` (*type:* `GoogleApi.ServiceControl.V1.Model.ResourceLocation.t`, *default:* `nil`) - The resource location information.\n*   `resourceName` (*type:* `String.t`, *default:* `nil`) - The resource or collection that is the target of the operation. The name is a scheme-less URI, not including the API service name. For example: \"projects/PROJECT_ID/zones/us-central1-a/instances\" \"projects/PROJECT_ID/datasets/DATASET_ID\"\n*   `resourceOriginalState` (*type:* `map()`, *default:* `nil`) - The resource's original state before mutation. Present only for operations which have successfully modified the targeted resource(s). In general, this field should contain all changed fields, except those that are already been included in `request`, `response`, `metadata` or `service_data` fields. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.\n*   `response` (*type:* `map()`, *default:* `nil`) - The operation response. This may not include all response elements, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.\n*   `serviceData` (*type:* `map()`, *default:* `nil`) - Deprecated. Use the `metadata` field instead. Other service-specific data about the request, response, and other activities.\n*   `serviceName` (*type:* `String.t`, *default:* `nil`) - The name of the API service performing the operation. For example, `\"compute.googleapis.com\"`.\n*   `status` (*type:* `GoogleApi.ServiceControl.V1.Model.Status.t`, *default:* `nil`) - The status of the overall operation.","ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AuditLog.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AuditLog.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Auth","doc":"This message defines request authentication attributes. Terminology is based on the JSON Web Token (JWT) standard, but the terms also correlate to concepts in other standards.","ref":"GoogleApi.ServiceControl.V1.Model.Auth.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Auth","doc":"*   `accessLevels` (*type:* `list(String.t)`, *default:* `nil`) - A list of access level resource names that allow resources to be accessed by authenticated requester. It is part of Secure GCP processing for the incoming request. An access level string has the format: \"//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}\" Example: \"//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL\"\n*   `audiences` (*type:* `list(String.t)`, *default:* `nil`) - The intended audience(s) for this authentication information. Reflects the audience (`aud`) claim within a JWT. The audience value(s) depends on the `issuer`, but typically include one or more of the following pieces of information: * The services intended to receive the credential. For example, [\"https://pubsub.googleapis.com/\", \"https://storage.googleapis.com/\"]. * A set of service-based scopes. For example, [\"https://www.googleapis.com/auth/cloud-platform\"]. * The client id of an app, such as the Firebase project id for JWTs from Firebase Auth. Consult the documentation for the credential issuer to determine the information provided.\n*   `claims` (*type:* `map()`, *default:* `nil`) - Structured claims presented with the credential. JWTs include `{key: value}` pairs for standard and private claims. The following is a subset of the standard required and optional claims that would typically be presented for a Google-based JWT: {'iss': 'accounts.google.com', 'sub': '113289723416554971153', 'aud': ['123456789012', 'pubsub.googleapis.com'], 'azp': '123456789012.apps.googleusercontent.com', 'email': 'jsmith@example.com', 'iat': 1353601026, 'exp': 1353604926} SAML assertions are similarly specified, but with an identity provider dependent structure.\n*   `presenter` (*type:* `String.t`, *default:* `nil`) - The authorized presenter of the credential. Reflects the optional Authorized Presenter (`azp`) claim within a JWT or the OAuth client id. For example, a Google Cloud Platform client id looks as follows: \"123456789012.apps.googleusercontent.com\".\n*   `principal` (*type:* `String.t`, *default:* `nil`) - The authenticated principal. Reflects the issuer (`iss`) and subject (`sub`) claims within a JWT. The issuer and subject should be `/` delimited, with `/` percent-encoded within the subject fragment. For Google accounts, the principal format is: \"https://accounts.google.com/{id}\"","ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Auth.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Auth.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo","doc":"Authentication information for the operation.","ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AuthenticationInfo","doc":"*   `authoritySelector` (*type:* `String.t`, *default:* `nil`) - The authority selector specified by the requestor, if any. It is not guaranteed that the principal was allowed to use this authority.\n*   `principalEmail` (*type:* `String.t`, *default:* `nil`) - The email address of the authenticated user (or service account on behalf of third party principal) making the request. For third party identity callers, the `principal_subject` field is populated instead of this field. For privacy reasons, the principal email address is sometimes redacted. For more information, see [Caller identities in audit logs](https://cloud.google.com/logging/docs/audit#user-id).\n*   `principalSubject` (*type:* `String.t`, *default:* `nil`) - String representation of identity of requesting party. Populated for both first and third party identities.\n*   `serviceAccountDelegationInfo` (*type:* `list(GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.t)`, *default:* `nil`) - Identity delegation history of an authenticated service account that makes the request. It contains information on the real authorities that try to access GCP resources by delegating on a service account. When multiple authorities present, they are guaranteed to be sorted based on the original ordering of the identity delegation events.\n*   `serviceAccountKeyName` (*type:* `String.t`, *default:* `nil`) - The name of the service account key used to create or exchange credentials for authenticating the service account making the request. This is a scheme-less URI full resource name. For example: \"//iam.googleapis.com/projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}\"\n*   `serviceDelegationHistory` (*type:* `GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.t`, *default:* `nil`) - Records the history of delegated resource access across Google services.\n*   `thirdPartyPrincipal` (*type:* `map()`, *default:* `nil`) - The third party identification (if any) of the authenticated user making the request. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.","ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo","doc":"Authorization information for the operation.","ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.AuthorizationInfo","doc":"*   `granted` (*type:* `boolean()`, *default:* `nil`) - Whether or not authorization for `resource` and `permission` was granted.\n*   `permission` (*type:* `String.t`, *default:* `nil`) - The required IAM permission.\n*   `resource` (*type:* `String.t`, *default:* `nil`) - The resource being accessed, as a REST-style or cloud resource string. For example: bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID or projects/PROJECTID/datasets/DATASETID\n*   `resourceAttributes` (*type:* `GoogleApi.ServiceControl.V1.Model.Resource.t`, *default:* `nil`) - Resource attributes used in IAM condition evaluation. This field contains resource attributes like resource type and resource name. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into `AuditLog.request_metadata.request_attributes`.","ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.CheckError","doc":"Defines the errors to be returned in google.api.servicecontrol.v1.CheckResponse.check_errors.","ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.CheckError","doc":"*   `code` (*type:* `String.t`, *default:* `nil`) - The error code.\n*   `detail` (*type:* `String.t`, *default:* `nil`) - Free-form text providing details on the error cause of the error.\n*   `status` (*type:* `GoogleApi.ServiceControl.V1.Model.Status.t`, *default:* `nil`) - Contains public information about the check error. If available, `status.code` will be non zero and client can propagate it out as public error.\n*   `subject` (*type:* `String.t`, *default:* `nil`) - Subject to whom this error applies. See the specific code enum for more details on this field. For example: - \"project:\" - \"folder:\" - \"organization:\"","ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.CheckError.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.CheckError.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo","doc":"Contains additional information about the check operation.","ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.CheckInfo","doc":"*   `apiKeyUid` (*type:* `String.t`, *default:* `nil`) - The unique id of the api key in the format of \"apikey:\". This field will be populated when the consumer passed to Chemist is an API key and all the API key related validations are successful.\n*   `consumerInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.ConsumerInfo.t`, *default:* `nil`) - Consumer info of this check.\n*   `unusedArguments` (*type:* `list(String.t)`, *default:* `nil`) - A list of fields and label keys that are ignored by the server. The client doesn't need to send them for following requests to improve performance and allow better aggregation.","ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest","doc":"Request message for the Check method.","ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.CheckRequest","doc":"*   `operation` (*type:* `GoogleApi.ServiceControl.V1.Model.Operation.t`, *default:* `nil`) - The operation to be checked.\n*   `requestProjectSettings` (*type:* `boolean()`, *default:* `nil`) - Requests the project settings to be returned as part of the check response.\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used.\n*   `skipActivationCheck` (*type:* `boolean()`, *default:* `nil`) - Indicates if service activation check should be skipped for this request. Default behavior is to perform the check and apply relevant quota. WARNING: Setting this flag to \"true\" will disable quota enforcement.","ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse","doc":"Response message for the Check method.","ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.CheckResponse","doc":"*   `checkErrors` (*type:* `list(GoogleApi.ServiceControl.V1.Model.CheckError.t)`, *default:* `nil`) - Indicate the decision of the check. If no check errors are present, the service should process the operation. Otherwise the service should use the list of errors to determine the appropriate action.\n*   `checkInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.CheckInfo.t`, *default:* `nil`) - Feedback data returned from the server during processing a Check request.\n*   `operationId` (*type:* `String.t`, *default:* `nil`) - The same operation_id value used in the CheckRequest. Used for logging and diagnostics purposes.\n*   `quotaInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.QuotaInfo.t`, *default:* `nil`) - Quota information for the check request associated with this response. \n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - The actual config id used to process the request.\n*   `serviceRolloutId` (*type:* `String.t`, *default:* `nil`) - The current service rollout id used to process the request.","ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo","doc":"`ConsumerInfo` provides information about the consumer.","ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ConsumerInfo","doc":"*   `consumerNumber` (*type:* `String.t`, *default:* `nil`) - The consumer identity number, can be Google cloud project number, folder number or organization number e.g. 1234567890. A value of 0 indicates no consumer number is found.\n*   `projectNumber` (*type:* `String.t`, *default:* `nil`) - The Google cloud project number, e.g. 1234567890. A value of 0 indicates no project number is found. NOTE: This field is deprecated after Chemist support flexible consumer id. New code should not depend on this field anymore.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of the consumer which should have been defined in [Google Resource Manager](https://cloud.google.com/resource-manager/).","ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Distribution","doc":"Distribution represents a frequency distribution of double-valued sample points. It contains the size of the population of sample points plus additional optional information: * the arithmetic mean of the samples * the minimum and maximum of the samples * the sum-squared-deviation of the samples, used to compute variance * a histogram of the values of the sample points","ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Distribution","doc":"*   `bucketCounts` (*type:* `list(String.t)`, *default:* `nil`) - The number of samples in each histogram bucket. `bucket_counts` are optional. If present, they must sum to the `count` value. The buckets are defined below in `bucket_option`. There are N buckets. `bucket_counts[0]` is the number of samples in the underflow bucket. `bucket_counts[1]` to `bucket_counts[N-1]` are the numbers of samples in each of the finite buckets. And `bucket_counts[N] is the number of samples in the overflow bucket. See the comments of `bucket_option` below for more details. Any suffix of trailing zeros may be omitted.\n*   `count` (*type:* `String.t`, *default:* `nil`) - The total number of samples in the distribution. Must be >= 0.\n*   `exemplars` (*type:* `list(GoogleApi.ServiceControl.V1.Model.Exemplar.t)`, *default:* `nil`) - Example points. Must be in increasing order of `value` field.\n*   `explicitBuckets` (*type:* `GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.t`, *default:* `nil`) - Buckets with arbitrary user-provided width.\n*   `exponentialBuckets` (*type:* `GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.t`, *default:* `nil`) - Buckets with exponentially growing width.\n*   `linearBuckets` (*type:* `GoogleApi.ServiceControl.V1.Model.LinearBuckets.t`, *default:* `nil`) - Buckets with constant width.\n*   `maximum` (*type:* `float()`, *default:* `nil`) - The maximum of the population of values. Ignored if `count` is zero.\n*   `mean` (*type:* `float()`, *default:* `nil`) - The arithmetic mean of the samples in the distribution. If `count` is zero then this field must be zero.\n*   `minimum` (*type:* `float()`, *default:* `nil`) - The minimum of the population of values. Ignored if `count` is zero.\n*   `sumOfSquaredDeviation` (*type:* `float()`, *default:* `nil`) - The sum of squared deviations from the mean: Sum[i=1..count]((x_i - mean)^2) where each x_i is a sample values. If `count` is zero then this field must be zero, otherwise validation of the request fails.","ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Distribution.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Distribution.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Exemplar","doc":"Exemplars are example points that may be used to annotate aggregated distribution values. They are metadata that gives information about a particular value added to a Distribution bucket, such as a trace ID that was active when a value was added. They may contain further information, such as a example values and timestamps, origin, etc.","ref":"GoogleApi.ServiceControl.V1.Model.Exemplar.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Exemplar","doc":"*   `attachments` (*type:* `list(map())`, *default:* `nil`) - Contextual information about the example value. Examples are: Trace: type.googleapis.com/google.monitoring.v3.SpanContext Literal string: type.googleapis.com/google.protobuf.StringValue Labels dropped during aggregation: type.googleapis.com/google.monitoring.v3.DroppedLabels There may be only a single attachment of any given message type in a single exemplar, and this is enforced by the system.\n*   `timestamp` (*type:* `DateTime.t`, *default:* `nil`) - The observation (sampling) time of the above value.\n*   `value` (*type:* `float()`, *default:* `nil`) - Value of the exemplar point. This value determines to which bucket the exemplar belongs.","ref":"GoogleApi.ServiceControl.V1.Model.Exemplar.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Exemplar.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Exemplar.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Exemplar.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Exemplar.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets","doc":"Describing buckets with arbitrary user-provided width.","ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ExplicitBuckets","doc":"*   `bounds` (*type:* `list(float())`, *default:* `nil`) - 'bound' is a list of strictly increasing boundaries between buckets. Note that a list of length N-1 defines N buckets because of fenceposting. See comments on `bucket_options` for details. The i'th finite bucket covers the interval [bound[i-1], bound[i]) where i ranges from 1 to bound_size() - 1. Note that there are no finite buckets at all if 'bound' only contains a single element; in that special case the single bound defines the boundary between the underflow and overflow buckets. bucket number lower bound upper bound i == 0 (underflow) -inf bound[i] 0 < i < bound_size() bound[i-1] bound[i] i == bound_size() (overflow) bound[i-1] +inf","ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets","doc":"Describing buckets with exponentially growing width.","ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ExponentialBuckets","doc":"*   `growthFactor` (*type:* `float()`, *default:* `nil`) - The i'th exponential bucket covers the interval [scale * growth_factor^(i-1), scale * growth_factor^i) where i ranges from 1 to num_finite_buckets inclusive. Must be larger than 1.0.\n*   `numFiniteBuckets` (*type:* `integer()`, *default:* `nil`) - The number of finite buckets. With the underflow and overflow buckets, the total number of buckets is `num_finite_buckets` + 2. See comments on `bucket_options` for details.\n*   `scale` (*type:* `float()`, *default:* `nil`) - The i'th exponential bucket covers the interval [scale * growth_factor^(i-1), scale * growth_factor^i) where i ranges from 1 to num_finite_buckets inclusive. Must be > 0.","ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal","doc":"First party identity principal.","ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal","doc":"*   `principalEmail` (*type:* `String.t`, *default:* `nil`) - The email address of a Google account. .\n*   `serviceMetadata` (*type:* `map()`, *default:* `nil`) - Metadata about the service that uses the service account. .","ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest","doc":"A common proto for logging HTTP requests. Only contains semantics defined by the HTTP specification. Product-specific logging information MUST be defined in a separate message.","ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.HttpRequest","doc":"*   `cacheFillBytes` (*type:* `String.t`, *default:* `nil`) - The number of HTTP response bytes inserted into cache. Set only when a cache fill was attempted.\n*   `cacheHit` (*type:* `boolean()`, *default:* `nil`) - Whether or not an entity was served from cache (with or without validation).\n*   `cacheLookup` (*type:* `boolean()`, *default:* `nil`) - Whether or not a cache lookup was attempted.\n*   `cacheValidatedWithOriginServer` (*type:* `boolean()`, *default:* `nil`) - Whether or not the response was validated with the origin server before being served from cache. This field is only meaningful if `cache_hit` is True.\n*   `latency` (*type:* `String.t`, *default:* `nil`) - The request processing latency on the server, from the time the request was received until the response was sent.\n*   `protocol` (*type:* `String.t`, *default:* `nil`) - Protocol used for the request. Examples: \"HTTP/1.1\", \"HTTP/2\", \"websocket\"\n*   `referer` (*type:* `String.t`, *default:* `nil`) - The referer URL of the request, as defined in [HTTP/1.1 Header Field Definitions](http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html).\n*   `remoteIp` (*type:* `String.t`, *default:* `nil`) - The IP address (IPv4 or IPv6) of the client that issued the HTTP request. Examples: `\"192.168.1.1\"`, `\"FE80::0202:B3FF:FE1E:8329\"`.\n*   `requestMethod` (*type:* `String.t`, *default:* `nil`) - The request method. Examples: `\"GET\"`, `\"HEAD\"`, `\"PUT\"`, `\"POST\"`.\n*   `requestSize` (*type:* `String.t`, *default:* `nil`) - The size of the HTTP request message in bytes, including the request headers and the request body.\n*   `requestUrl` (*type:* `String.t`, *default:* `nil`) - The scheme (http, https), the host name, the path, and the query portion of the URL that was requested. Example: `\"http://example.com/some/info?color=red\"`.\n*   `responseSize` (*type:* `String.t`, *default:* `nil`) - The size of the HTTP response message sent back to the client, in bytes, including the response headers and the response body.\n*   `serverIp` (*type:* `String.t`, *default:* `nil`) - The IP address (IPv4 or IPv6) of the origin server that the request was sent to.\n*   `status` (*type:* `integer()`, *default:* `nil`) - The response code indicating the status of the response. Examples: 200, 404.\n*   `userAgent` (*type:* `String.t`, *default:* `nil`) - The user agent sent by the client. Example: `\"Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; Q312461; .NET CLR 1.0.3705)\"`.","ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets","doc":"Describing buckets with constant width.","ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.LinearBuckets","doc":"*   `numFiniteBuckets` (*type:* `integer()`, *default:* `nil`) - The number of finite buckets. With the underflow and overflow buckets, the total number of buckets is `num_finite_buckets` + 2. See comments on `bucket_options` for details.\n*   `offset` (*type:* `float()`, *default:* `nil`) - The i'th linear bucket covers the interval [offset + (i-1) * width, offset + i * width) where i ranges from 1 to num_finite_buckets, inclusive.\n*   `width` (*type:* `float()`, *default:* `nil`) - The i'th linear bucket covers the interval [offset + (i-1) * width, offset + i * width) where i ranges from 1 to num_finite_buckets, inclusive. Must be strictly positive.","ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.LogEntry","doc":"An individual log entry.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.LogEntry","doc":"*   `httpRequest` (*type:* `GoogleApi.ServiceControl.V1.Model.HttpRequest.t`, *default:* `nil`) - Optional. Information about the HTTP request associated with this log entry, if applicable.\n*   `insertId` (*type:* `String.t`, *default:* `nil`) - A unique ID for the log entry used for deduplication. If omitted, the implementation will generate one based on operation_id.\n*   `labels` (*type:* `map()`, *default:* `nil`) - A set of user-defined (key, value) data that provides additional information about the log entry.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The log to which this log entry belongs. Examples: `\"syslog\"`, `\"book_log\"`.\n*   `operation` (*type:* `GoogleApi.ServiceControl.V1.Model.LogEntryOperation.t`, *default:* `nil`) - Optional. Information about an operation associated with the log entry, if applicable.\n*   `protoPayload` (*type:* `map()`, *default:* `nil`) - The log entry payload, represented as a protocol buffer that is expressed as a JSON object. The only accepted type currently is AuditLog.\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of the log entry. The default value is `LogSeverity.DEFAULT`.\n*   `sourceLocation` (*type:* `GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.t`, *default:* `nil`) - Optional. Source code location information associated with the log entry, if any.\n*   `structPayload` (*type:* `map()`, *default:* `nil`) - The log entry payload, represented as a structure that is expressed as a JSON object.\n*   `textPayload` (*type:* `String.t`, *default:* `nil`) - The log entry payload, represented as a Unicode string (UTF-8).\n*   `timestamp` (*type:* `DateTime.t`, *default:* `nil`) - The time the event described by the log entry occurred. If omitted, defaults to operation start time.\n*   `trace` (*type:* `String.t`, *default:* `nil`) - Optional. Resource name of the trace associated with the log entry, if any. If this field contains a relative resource name, you can assume the name is relative to `//tracing.googleapis.com`. Example: `projects/my-projectid/traces/06796866738c859f2f19b7cfb3214824`","ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.LogEntry.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.LogEntry.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation","doc":"Additional information about a potentially long-running operation with which a log entry is associated.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.LogEntryOperation","doc":"*   `first` (*type:* `boolean()`, *default:* `nil`) - Optional. Set this to True if this is the first log entry in the operation.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Optional. An arbitrary operation identifier. Log entries with the same identifier are assumed to be part of the same operation.\n*   `last` (*type:* `boolean()`, *default:* `nil`) - Optional. Set this to True if this is the last log entry in the operation.\n*   `producer` (*type:* `String.t`, *default:* `nil`) - Optional. An arbitrary producer identifier. The combination of `id` and `producer` must be globally unique. Examples for `producer`: `\"MyDivision.MyBigCompany.com\"`, `\"github.com/MyProject/MyApplication\"`.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation","doc":"Additional information about the source code location that produced the log entry.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation","doc":"*   `file` (*type:* `String.t`, *default:* `nil`) - Optional. Source file name. Depending on the runtime environment, this might be a simple name or a fully-qualified name.\n*   `function` (*type:* `String.t`, *default:* `nil`) - Optional. Human-readable name of the function or method being invoked, with optional context such as the class or package name. This information may be used in contexts such as the logs viewer, where a file and line number are less meaningful. The format can vary by language. For example: `qual.if.ied.Class.method` (Java), `dir/package.func` (Go), `function` (Python).\n*   `line` (*type:* `String.t`, *default:* `nil`) - Optional. Line within the source file. 1-based; 0 indicates no line number available.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.LogEntrySourceLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.MetricValue","doc":"Represents a single metric value.","ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.MetricValue","doc":"*   `boolValue` (*type:* `boolean()`, *default:* `nil`) - A boolean value.\n*   `distributionValue` (*type:* `GoogleApi.ServiceControl.V1.Model.Distribution.t`, *default:* `nil`) - A distribution value.\n*   `doubleValue` (*type:* `float()`, *default:* `nil`) - A double precision floating point value.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The end of the time period over which this metric value's measurement applies. If not specified, google.api.servicecontrol.v1.Operation.end_time will be used.\n*   `int64Value` (*type:* `String.t`, *default:* `nil`) - A signed 64-bit integer value.\n*   `labels` (*type:* `map()`, *default:* `nil`) - The labels describing the metric value. See comments on google.api.servicecontrol.v1.Operation.labels for the overriding relationship. Note that this map must not contain monitored resource labels.\n*   `moneyValue` (*type:* `GoogleApi.ServiceControl.V1.Model.Money.t`, *default:* `nil`) - A money value.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The start of the time period over which this metric value's measurement applies. The time period has different semantics for different metric types (cumulative, delta, and gauge). See the metric definition documentation in the service configuration for details. If not specified, google.api.servicecontrol.v1.Operation.start_time will be used.\n*   `stringValue` (*type:* `String.t`, *default:* `nil`) - A text string value.","ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.MetricValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.MetricValue.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet","doc":"Represents a set of metric values in the same metric. Each metric value in the set should have a unique combination of start time, end time, and label values.","ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.MetricValueSet","doc":"*   `metricName` (*type:* `String.t`, *default:* `nil`) - The metric name defined in the service configuration.\n*   `metricValues` (*type:* `list(GoogleApi.ServiceControl.V1.Model.MetricValue.t)`, *default:* `nil`) - The values in this metric.","ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Money","doc":"Represents an amount of money with its currency type.","ref":"GoogleApi.ServiceControl.V1.Model.Money.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Money","doc":"*   `currencyCode` (*type:* `String.t`, *default:* `nil`) - The three-letter currency code defined in ISO 4217.\n*   `nanos` (*type:* `integer()`, *default:* `nil`) - Number of nano (10^-9) units of the amount. The value must be between -999,999,999 and +999,999,999 inclusive. If `units` is positive, `nanos` must be positive or zero. If `units` is zero, `nanos` can be positive, zero, or negative. If `units` is negative, `nanos` must be negative or zero. For example $-1.75 is represented as `units`=-1 and `nanos`=-750,000,000.\n*   `units` (*type:* `String.t`, *default:* `nil`) - The whole units of the amount. For example if `currencyCode` is `\"USD\"`, then 1 unit is one US dollar.","ref":"GoogleApi.ServiceControl.V1.Model.Money.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Money.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Money.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Money.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Money.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Operation","doc":"Represents information regarding an operation.","ref":"GoogleApi.ServiceControl.V1.Model.Operation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Operation","doc":"*   `consumerId` (*type:* `String.t`, *default:* `nil`) - Identity of the consumer who is using the service. This field should be filled in for the operations initiated by a consumer, but not for service-initiated operations that are not related to a specific consumer. - This can be in one of the following formats: - project:PROJECT_ID, - project`_`number:PROJECT_NUMBER, - projects/PROJECT_ID or PROJECT_NUMBER, - folders/FOLDER_NUMBER, - organizations/ORGANIZATION_NUMBER, - api`_`key:API_KEY.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - End time of the operation. Required when the operation is used in ServiceController.Report, but optional when the operation is used in ServiceController.Check.\n*   `importance` (*type:* `String.t`, *default:* `nil`) - DO NOT USE. This is an experimental field.\n*   `labels` (*type:* `map()`, *default:* `nil`) - Labels describing the operation. Only the following labels are allowed: - Labels describing monitored resources as defined in the service configuration. - Default labels of metric values. When specified, labels defined in the metric value override these default. - The following labels defined by Google Cloud Platform: - `cloud.googleapis.com/location` describing the location where the operation happened, - `servicecontrol.googleapis.com/user_agent` describing the user agent of the API request, - `servicecontrol.googleapis.com/service_agent` describing the service used to handle the API request (e.g. ESP), - `servicecontrol.googleapis.com/platform` describing the platform where the API is served, such as App Engine, Compute Engine, or Kubernetes Engine.\n*   `logEntries` (*type:* `list(GoogleApi.ServiceControl.V1.Model.LogEntry.t)`, *default:* `nil`) - Represents information to be logged.\n*   `metricValueSets` (*type:* `list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)`, *default:* `nil`) - Represents information about this operation. Each MetricValueSet corresponds to a metric defined in the service configuration. The data type used in the MetricValueSet must agree with the data type specified in the metric definition. Within a single operation, it is not allowed to have more than one MetricValue instances that have the same metric names and identical label value combinations. If a request has such duplicated MetricValue instances, the entire request is rejected with an invalid argument error.\n*   `operationId` (*type:* `String.t`, *default:* `nil`) - Identity of the operation. This must be unique within the scope of the service that generated the operation. If the service calls Check() and Report() on the same operation, the two calls should carry the same id. UUID version 4 is recommended, though not required. In scenarios where an operation is computed from existing information and an idempotent id is desirable for deduplication purpose, UUID version 5 is recommended. See RFC 4122 for details.\n*   `operationName` (*type:* `String.t`, *default:* `nil`) - Fully qualified name of the operation. Reserved for future use.\n*   `quotaProperties` (*type:* `GoogleApi.ServiceControl.V1.Model.QuotaProperties.t`, *default:* `nil`) - Represents the properties needed for quota check. Applicable only if this operation is for a quota check request. If this is not specified, no quota check will be performed.\n*   `resources` (*type:* `list(GoogleApi.ServiceControl.V1.Model.ResourceInfo.t)`, *default:* `nil`) - The resources that are involved in the operation. The maximum supported number of entries in this field is 100.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Required. Start time of the operation.\n*   `traceSpans` (*type:* `list(GoogleApi.ServiceControl.V1.Model.TraceSpan.t)`, *default:* `nil`) - Unimplemented. A list of Cloud Trace spans. The span names shall contain the id of the destination project which can be either the produce or the consumer project.\n*   `userLabels` (*type:* `map()`, *default:* `nil`) - Private Preview. This feature is only available for approved services. User defined labels for the resource that this operation is associated with.","ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Operation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Operation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo","doc":"Represents OrgPolicy Violation information.","ref":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo","doc":"*   `payload` (*type:* `map()`, *default:* `nil`) - Optional. Resource payload that is currently in scope and is subjected to orgpolicy conditions. This payload may be the subset of the actual Resource that may come in the request. This payload should not contain any core content.\n*   `resourceTags` (*type:* `map()`, *default:* `nil`) - Optional. Tags referenced on the resource at the time of evaluation. These also include the federated tags, if they are supplied in the CheckOrgPolicy or CheckCustomConstraints Requests. Optional field as of now. These tags are the Cloud tags that are available on the resource during the policy evaluation and will be available as part of the OrgPolicy check response for logging purposes.\n*   `resourceType` (*type:* `String.t`, *default:* `nil`) - Optional. Resource type that the orgpolicy is checked against. Example: compute.googleapis.com/Instance, store.googleapis.com/bucket\n*   `violationInfo` (*type:* `list(GoogleApi.ServiceControl.V1.Model.ViolationInfo.t)`, *default:* `nil`) - Optional. Policy violations","ref":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Peer","doc":"This message defines attributes for a node that handles a network request. The node can be either a service or an application that sends, forwards, or receives the request. Service peers should fill in `principal` and `labels` as appropriate.","ref":"GoogleApi.ServiceControl.V1.Model.Peer.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Peer","doc":"*   `ip` (*type:* `String.t`, *default:* `nil`) - The IP address of the peer.\n*   `labels` (*type:* `map()`, *default:* `nil`) - The labels associated with the peer.\n*   `port` (*type:* `String.t`, *default:* `nil`) - The network port of the peer.\n*   `principal` (*type:* `String.t`, *default:* `nil`) - The identity of this peer. Similar to `Request.auth.principal`, but relative to the peer instead of the request. For example, the identity associated with a load balancer that forwarded the request.\n*   `regionCode` (*type:* `String.t`, *default:* `nil`) - The CLDR country/region code associated with the above IP address. If the IP address is private, the `region_code` should reflect the physical location where this peer is running.","ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Peer.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Peer.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo","doc":"Information related to policy violations for this request.","ref":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo","doc":"*   `orgPolicyViolationInfo` (*type:* `GoogleApi.ServiceControl.V1.Model.OrgPolicyViolationInfo.t`, *default:* `nil`) - Indicates the orgpolicy violations for this resource.","ref":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.PolicyViolationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.QuotaError","doc":"Represents error information for QuotaOperation.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.QuotaError","doc":"*   `code` (*type:* `String.t`, *default:* `nil`) - Error code.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Free-form text that provides details on the cause of the error.\n*   `status` (*type:* `GoogleApi.ServiceControl.V1.Model.Status.t`, *default:* `nil`) - Contains additional information about the quota error. If available, `status.code` will be non zero.\n*   `subject` (*type:* `String.t`, *default:* `nil`) - Subject to whom this error applies. See the specific enum for more details on this field. For example, \"clientip:\" or \"project:\".","ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.QuotaError.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.QuotaError.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo","doc":"Contains the quota information for a quota check response.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.QuotaInfo","doc":"*   `limitExceeded` (*type:* `list(String.t)`, *default:* `nil`) - Quota Metrics that have exceeded quota limits. For QuotaGroup-based quota, this is QuotaGroup.name For QuotaLimit-based quota, this is QuotaLimit.name See: google.api.Quota Deprecated: Use quota_metrics to get per quota group limit exceeded status.\n*   `quotaConsumed` (*type:* `map()`, *default:* `nil`) - Map of quota group name to the actual number of tokens consumed. If the quota check was not successful, then this will not be populated due to no quota consumption. We are not merging this field with 'quota_metrics' field because of the complexity of scaling in Chemist client code base. For simplicity, we will keep this field for Castor (that scales quota usage) and 'quota_metrics' for SuperQuota (that doesn't scale quota usage). \n*   `quotaMetrics` (*type:* `list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)`, *default:* `nil`) - Quota metrics to indicate the usage. Depending on the check request, one or more of the following metrics will be included: 1. For rate quota, per quota group or per quota metric incremental usage will be specified using the following delta metric: \"serviceruntime.googleapis.com/api/consumer/quota_used_count\" 2. For allocation quota, per quota metric total usage will be specified using the following gauge metric: \"serviceruntime.googleapis.com/allocation/consumer/quota_used_count\" 3. For both rate quota and allocation quota, the quota limit reached condition will be specified using the following boolean metric: \"serviceruntime.googleapis.com/quota/exceeded\"","ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation","doc":"Represents information regarding a quota operation.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.QuotaOperation","doc":"*   `consumerId` (*type:* `String.t`, *default:* `nil`) - Identity of the consumer for whom this quota operation is being performed. This can be in one of the following formats: project:, project_number:, api_key:.\n*   `labels` (*type:* `map()`, *default:* `nil`) - Labels describing the operation.\n*   `methodName` (*type:* `String.t`, *default:* `nil`) - Fully qualified name of the API method for which this quota operation is requested. This name is used for matching quota rules or metric rules and billing status rules defined in service configuration. This field should not be set if any of the following is true: (1) the quota operation is performed on non-API resources. (2) quota_metrics is set because the caller is doing quota override. Example of an RPC method name: google.example.library.v1.LibraryService.CreateShelf\n*   `operationId` (*type:* `String.t`, *default:* `nil`) - Identity of the operation. For Allocation Quota, this is expected to be unique within the scope of the service that generated the operation, and guarantees idempotency in case of retries. In order to ensure best performance and latency in the Quota backends, operation_ids are optimally associated with time, so that related operations can be accessed fast in storage. For this reason, the recommended token for services that intend to operate at a high QPS is Unix time in nanos + UUID\n*   `quotaMetrics` (*type:* `list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)`, *default:* `nil`) - Represents information about this operation. Each MetricValueSet corresponds to a metric defined in the service configuration. The data type used in the MetricValueSet must agree with the data type specified in the metric definition. Within a single operation, it is not allowed to have more than one MetricValue instances that have the same metric names and identical label value combinations. If a request has such duplicated MetricValue instances, the entire request is rejected with an invalid argument error. This field is mutually exclusive with method_name.\n*   `quotaMode` (*type:* `String.t`, *default:* `nil`) - Quota mode for this operation.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties","doc":"Represents the properties needed for quota operations.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.QuotaProperties","doc":"*   `quotaMode` (*type:* `String.t`, *default:* `nil`) - Quota mode for this operation.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ReportError","doc":"Represents the processing error of one Operation in the request.","ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ReportError","doc":"*   `operationId` (*type:* `String.t`, *default:* `nil`) - The Operation.operation_id value from the request.\n*   `status` (*type:* `GoogleApi.ServiceControl.V1.Model.Status.t`, *default:* `nil`) - Details of the error when processing the Operation.","ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ReportError.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ReportError.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest","doc":"Request message for the Report method.","ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ReportRequest","doc":"*   `operations` (*type:* `list(GoogleApi.ServiceControl.V1.Model.Operation.t)`, *default:* `nil`) - Operations to be reported. Typically the service should report one operation per request. Putting multiple operations into a single request is allowed, but should be used only when multiple operations are natually available at the time of the report. There is no limit on the number of operations in the same ReportRequest, however the ReportRequest size should be no larger than 1MB. See ReportResponse.report_errors for partial failure behavior.\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - Specifies which version of service config should be used to process the request. If unspecified or no matching version can be found, the latest one will be used.","ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse","doc":"Response message for the Report method.","ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ReportResponse","doc":"*   `reportErrors` (*type:* `list(GoogleApi.ServiceControl.V1.Model.ReportError.t)`, *default:* `nil`) - Partial failures, one for each `Operation` in the request that failed processing. There are three possible combinations of the RPC status: 1. The combination of a successful RPC status and an empty `report_errors` list indicates a complete success where all `Operations` in the request are processed successfully. 2. The combination of a successful RPC status and a non-empty `report_errors` list indicates a partial success where some `Operations` in the request succeeded. Each `Operation` that failed processing has a corresponding item in this list. 3. A failed RPC status indicates a general non-deterministic failure. When this happens, it's impossible to know which of the 'Operations' in the request succeeded or failed.\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - The actual config id used to process the request.\n*   `serviceRolloutId` (*type:* `String.t`, *default:* `nil`) - The current service rollout id used to process the request.","ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Request","doc":"This message defines attributes for an HTTP request. If the actual request is not an HTTP request, the runtime system should try to map the actual request to an equivalent HTTP request.","ref":"GoogleApi.ServiceControl.V1.Model.Request.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Request","doc":"*   `auth` (*type:* `GoogleApi.ServiceControl.V1.Model.Auth.t`, *default:* `nil`) - The request authentication. May be absent for unauthenticated requests. Derived from the HTTP request `Authorization` header or equivalent.\n*   `headers` (*type:* `map()`, *default:* `nil`) - The HTTP request headers. If multiple headers share the same key, they must be merged according to the HTTP spec. All header keys must be lowercased, because HTTP header keys are case-insensitive.\n*   `host` (*type:* `String.t`, *default:* `nil`) - The HTTP request `Host` header value.\n*   `id` (*type:* `String.t`, *default:* `nil`) - The unique ID for a request, which can be propagated to downstream systems. The ID should have low probability of collision within a single day for a specific service.\n*   `method` (*type:* `String.t`, *default:* `nil`) - The HTTP request method, such as `GET`, `POST`.\n*   `path` (*type:* `String.t`, *default:* `nil`) - The HTTP URL path, excluding the query parameters.\n*   `protocol` (*type:* `String.t`, *default:* `nil`) - The network protocol used with the request, such as \"http/1.1\", \"spdy/3\", \"h2\", \"h2c\", \"webrtc\", \"tcp\", \"udp\", \"quic\". See https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids for details.\n*   `query` (*type:* `String.t`, *default:* `nil`) - The HTTP URL query in the format of `name1=value1&name2=value2`, as it appears in the first line of the HTTP request. No decoding is performed.\n*   `reason` (*type:* `String.t`, *default:* `nil`) - A special parameter for request reason. It is used by security systems to associate auditing information with a request.\n*   `scheme` (*type:* `String.t`, *default:* `nil`) - The HTTP URL scheme, such as `http` and `https`.\n*   `size` (*type:* `String.t`, *default:* `nil`) - The HTTP request size in bytes. If unknown, it must be -1.\n*   `time` (*type:* `DateTime.t`, *default:* `nil`) - The timestamp when the `destination` service receives the last byte of the request.","ref":"GoogleApi.ServiceControl.V1.Model.Request.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Request.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Request.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Request.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Request.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata","doc":"Metadata about the request.","ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.RequestMetadata","doc":"*   `callerIp` (*type:* `String.t`, *default:* `nil`) - The IP address of the caller. For a caller from the internet, this will be the public IPv4 or IPv6 address. For calls made from inside Google's internal production network from one GCP service to another, `caller_ip` will be redacted to \"private\". For a caller from a Compute Engine VM with a external IP address, `caller_ip` will be the VM's external IP address. For a caller from a Compute Engine VM without a external IP address, if the VM is in the same organization (or project) as the accessed resource, `caller_ip` will be the VM's internal IPv4 address, otherwise `caller_ip` will be redacted to \"gce-internal-ip\". See https://cloud.google.com/compute/docs/vpc/ for more information.\n*   `callerNetwork` (*type:* `String.t`, *default:* `nil`) - The network of the caller. Set only if the network host project is part of the same GCP organization (or project) as the accessed resource. See https://cloud.google.com/compute/docs/vpc/ for more information. This is a scheme-less URI full resource name. For example: \"//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID\"\n*   `callerSuppliedUserAgent` (*type:* `String.t`, *default:* `nil`) - The user agent of the caller. This information is not authenticated and should be treated accordingly. For example: + `google-api-python-client/1.4.0`: The request was made by the Google API client for Python. + `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`: The request was made by the Google Cloud SDK CLI (gcloud). + `AppEngine-Google; (+http://code.google.com/appengine; appid: s~my-project`: The request was made from the `my-project` App Engine app.\n*   `destinationAttributes` (*type:* `GoogleApi.ServiceControl.V1.Model.Peer.t`, *default:* `nil`) - The destination of a network activity, such as accepting a TCP connection. In a multi hop network activity, the destination represents the receiver of the last hop. Only two fields are used in this message, Peer.port and Peer.ip. These fields are optionally populated by those services utilizing the IAM condition feature.\n*   `requestAttributes` (*type:* `GoogleApi.ServiceControl.V1.Model.Request.t`, *default:* `nil`) - Request attributes used in IAM condition evaluation. This field contains request attributes like request time and access levels associated with the request. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into `AuditLog.authentication_info.resource_attributes`.","ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Resource","doc":"This message defines core attributes for a resource. A resource is an addressable (named) entity provided by the destination service. For example, a file stored on a network storage service.","ref":"GoogleApi.ServiceControl.V1.Model.Resource.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Resource","doc":"*   `annotations` (*type:* `map()`, *default:* `nil`) - Annotations is an unstructured key-value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations/\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the resource was created. This may be either the time creation was initiated or when it was completed.\n*   `deleteTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the resource was deleted. If the resource is not deleted, this must be empty.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - Mutable. The display name set by clients. Must be <= 63 characters.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - Output only. An opaque value that uniquely identifies a version or generation of a resource. It can be used to confirm that the client and server agree on the ordering of a resource being written.\n*   `labels` (*type:* `map()`, *default:* `nil`) - The labels or tags on the resource, such as AWS resource tags and Kubernetes resource labels.\n*   `location` (*type:* `String.t`, *default:* `nil`) - Immutable. The location of the resource. The location encoding is specific to the service provider, and new encoding may be introduced as the service evolves. For Google Cloud products, the encoding is what is used by Google Cloud APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The semantics of `location` is identical to the `cloud.googleapis.com/location` label used by some Google Cloud APIs.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The stable identifier (name) of a resource on the `service`. A resource can be logically identified as \"//{resource.service}/{resource.name}\". The differences between a resource name and a URI are: * Resource name is a logical identifier, independent of network protocol and API version. For example, `//pubsub.googleapis.com/projects/123/topics/news-feed`. * URI often includes protocol and version information, so it can be used directly by applications. For example, `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`. See https://cloud.google.com/apis/design/resource_names for details.\n*   `service` (*type:* `String.t`, *default:* `nil`) - The name of the service that this resource belongs to, such as `pubsub.googleapis.com`. The service may be different from the DNS hostname that actually serves the request.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of the resource. The syntax is platform-specific because different platforms define their resources differently. For Google APIs, the type format must be \"{service}/{kind}\", such as \"pubsub.googleapis.com/Topic\".\n*   `uid` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the resource. UID is unique in the time and space for this resource within the scope of the service. It is typically generated by the server on successful creation of a resource and must not be changed. UID is used to uniquely identify resources with resource name reuses. This should be a UUID4.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the resource was last updated. Any change to the resource made by users must refresh this value. Changes to a resource made by the service should refresh this value.","ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Resource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Resource.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo","doc":"Describes a resource associated with this operation.","ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ResourceInfo","doc":"*   `permission` (*type:* `String.t`, *default:* `nil`) - The resource permission required for this request.\n*   `resourceContainer` (*type:* `String.t`, *default:* `nil`) - The identifier of the parent of this resource instance. Must be in one of the following formats: - `projects/` - `folders/` - `organizations/`\n*   `resourceLocation` (*type:* `String.t`, *default:* `nil`) - The location of the resource. If not empty, the resource will be checked against location policy. The value must be a valid zone, region or multiregion. For example: \"europe-west4\" or \"northamerica-northeast1-a\"\n*   `resourceName` (*type:* `String.t`, *default:* `nil`) - Name of the resource. This is used for auditing purposes.","ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation","doc":"Location information about a resource.","ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ResourceLocation","doc":"*   `currentLocations` (*type:* `list(String.t)`, *default:* `nil`) - The locations of a resource after the execution of the operation. Requests to create or delete a location based resource must populate the 'current_locations' field and not the 'original_locations' field. For example: \"europe-west1-a\" \"us-east1\" \"nam3\"\n*   `originalLocations` (*type:* `list(String.t)`, *default:* `nil`) - The locations of a resource prior to the execution of the operation. Requests that mutate the resource's location must populate both the 'original_locations' as well as the 'current_locations' fields. For example: \"europe-west1-a\" \"us-east1\" \"nam3\"","ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo","doc":"Identity delegation history of an authenticated service account.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo","doc":"*   `firstPartyPrincipal` (*type:* `GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.t`, *default:* `nil`) - First party (Google) identity as the real authority.\n*   `principalSubject` (*type:* `String.t`, *default:* `nil`) - A string representing the principal_subject associated with the identity. For most identities, the format will be `principal://iam.googleapis.com/{identity pool name}/subject/{subject)` except for some GKE identities (GKE_WORKLOAD, FREEFORM, GKE_HUB_WORKLOAD) that are still in the legacy format `serviceAccount:{identity pool name}[{subject}]`\n*   `thirdPartyPrincipal` (*type:* `GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.t`, *default:* `nil`) - Third party identity as the real authority.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory","doc":"The history of delegation across multiple services as the result of the original user's action. Such as \"service A uses its own account to do something for user B\". This differs from ServiceAccountDelegationInfo, which only tracks the history of direct token exchanges (impersonation).","ref":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory","doc":"*   `originalPrincipal` (*type:* `String.t`, *default:* `nil`) - The original end user who initiated the request to GCP.\n*   `serviceMetadata` (*type:* `list(GoogleApi.ServiceControl.V1.Model.ServiceMetadata.t)`, *default:* `nil`) - Data identifying the service specific jobs or units of work that were involved in a chain of service calls.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ServiceDelegationHistory.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata","doc":"Metadata describing the service and additional service specific information used to identify the job or unit of work at hand.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ServiceMetadata","doc":"*   `jobMetadata` (*type:* `map()`, *default:* `nil`) - Additional metadata provided by service teams to describe service specific job information that was triggered by the original principal.\n*   `principalSubject` (*type:* `String.t`, *default:* `nil`) - A string representing the principal_subject associated with the identity. For most identities, the format will be `principal://iam.googleapis.com/{identity pool name}/subject/{subject)` except for some GKE identities (GKE_WORKLOAD, FREEFORM, GKE_HUB_WORKLOAD) that are still in the legacy format `serviceAccount:{identity pool name}[{subject}]` If the identity is a Google account (e.g. workspace user account or service account), this will be the email of the prefixed by `serviceAccount:`. For example: `serviceAccount:my-service-account@project-1.iam.gserviceaccount.com`. If the identity is an individual user, the identity will be formatted as: `user:user_ABC@email.com`.\n*   `serviceDomain` (*type:* `String.t`, *default:* `nil`) - The service's fully qualified domain name, e.g. \"dataproc.googleapis.com\".","ref":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ServiceMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.SpanContext","doc":"The context of a span. This is attached to an Exemplar in Distribution values during aggregation. It contains the name of a span with format: projects/[PROJECT_ID_OR_NUMBER]/traces/[TRACE_ID]/spans/[SPAN_ID]","ref":"GoogleApi.ServiceControl.V1.Model.SpanContext.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.SpanContext","doc":"*   `spanName` (*type:* `String.t`, *default:* `nil`) - The resource name of the span. The format is: projects/[PROJECT_ID_OR_NUMBER]/traces/[TRACE_ID]/spans/[SPAN_ID] `[TRACE_ID]` is a unique identifier for a trace within a project; it is a 32-character hexadecimal encoding of a 16-byte array. `[SPAN_ID]` is a unique identifier for a span within a trace; it is a 16-character hexadecimal encoding of an 8-byte array.","ref":"GoogleApi.ServiceControl.V1.Model.SpanContext.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.SpanContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.SpanContext.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.SpanContext.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.SpanContext.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.Status","doc":"The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).","ref":"GoogleApi.ServiceControl.V1.Model.Status.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.Status","doc":"*   `code` (*type:* `integer()`, *default:* `nil`) - The status code, which should be an enum value of google.rpc.Code.\n*   `details` (*type:* `list(map())`, *default:* `nil`) - A list of messages that carry the error details. There is a common set of message types for APIs to use.\n*   `message` (*type:* `String.t`, *default:* `nil`) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.","ref":"GoogleApi.ServiceControl.V1.Model.Status.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.Status.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.Status.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.Status.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.Status.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal","doc":"Third party identity principal.","ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal","doc":"*   `thirdPartyClaims` (*type:* `map()`, *default:* `nil`) - Metadata about third party identity.","ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.TraceSpan","doc":"A span represents a single operation within a trace. Spans can be nested to form a trace tree. Often, a trace contains a root span that describes the end-to-end latency, and one or more subspans for its sub-operations. A trace can also contain multiple root spans, or none at all. Spans do not need to be contiguous—there may be gaps or overlaps between spans in a trace.","ref":"GoogleApi.ServiceControl.V1.Model.TraceSpan.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.TraceSpan","doc":"*   `attributes` (*type:* `GoogleApi.ServiceControl.V1.Model.Attributes.t`, *default:* `nil`) - A set of attributes on the span. You can have up to 32 attributes per span.\n*   `childSpanCount` (*type:* `integer()`, *default:* `nil`) - An optional number of child spans that were generated while this span was active. If set, allows implementation to detect missing child spans.\n*   `displayName` (*type:* `GoogleApi.ServiceControl.V1.Model.TruncatableString.t`, *default:* `nil`) - A description of the span's operation (up to 128 bytes). Stackdriver Trace displays the description in the Google Cloud Platform Console. For example, the display name can be a qualified method name or a file name and a line number where the operation is called. A best practice is to use the same display name within an application and at the same call point. This makes it easier to correlate spans in different traces.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The end time of the span. On the client side, this is the time kept by the local machine where the span execution ends. On the server side, this is the time when the server application handler stops running.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the span in the following format: projects/[PROJECT_ID]/traces/[TRACE_ID]/spans/SPAN_ID is a unique identifier for a trace within a project; it is a 32-character hexadecimal encoding of a 16-byte array. [SPAN_ID] is a unique identifier for a span within a trace; it is a 16-character hexadecimal encoding of an 8-byte array.\n*   `parentSpanId` (*type:* `String.t`, *default:* `nil`) - The [SPAN_ID] of this span's parent span. If this is a root span, then this field must be empty.\n*   `sameProcessAsParentSpan` (*type:* `boolean()`, *default:* `nil`) - (Optional) Set this parameter to indicate whether this span is in the same process as its parent. If you do not set this parameter, Stackdriver Trace is unable to take advantage of this helpful information.\n*   `spanId` (*type:* `String.t`, *default:* `nil`) - The [SPAN_ID] portion of the span's resource name.\n*   `spanKind` (*type:* `String.t`, *default:* `nil`) - Distinguishes between spans generated in a particular context. For example, two spans with the same name may be distinguished using `CLIENT` (caller) and `SERVER` (callee) to identify an RPC call.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The start time of the span. On the client side, this is the time kept by the local machine where the span execution starts. On the server side, this is the time when the server's application handler starts running.\n*   `status` (*type:* `GoogleApi.ServiceControl.V1.Model.Status.t`, *default:* `nil`) - An optional final status for this span.","ref":"GoogleApi.ServiceControl.V1.Model.TraceSpan.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.TraceSpan.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.TraceSpan.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.TraceSpan.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.TraceSpan.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.TruncatableString","doc":"Represents a string that might be shortened to a specified length.","ref":"GoogleApi.ServiceControl.V1.Model.TruncatableString.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.TruncatableString","doc":"*   `truncatedByteCount` (*type:* `integer()`, *default:* `nil`) - The number of bytes removed from the original string. If this value is 0, then the string was not shortened.\n*   `value` (*type:* `String.t`, *default:* `nil`) - The shortened string. For example, if the original string is 500 bytes long and the limit of the string is 128 bytes, then `value` contains the first 128 bytes of the 500-byte string. Truncation always happens on a UTF8 character boundary. If there are multi-byte characters in the string, then the length of the shortened string might be less than the size limit.","ref":"GoogleApi.ServiceControl.V1.Model.TruncatableString.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.TruncatableString.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.TruncatableString.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.TruncatableString.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.TruncatableString.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest","doc":"A common proto for logging HTTP requests. Only contains semantics defined by the HTTP specification. Product-specific logging information MUST be defined in a separate message.","ref":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.V1HttpRequest","doc":"*   `cacheFillBytes` (*type:* `String.t`, *default:* `nil`) - The number of HTTP response bytes inserted into cache. Set only when a cache fill was attempted.\n*   `cacheHit` (*type:* `boolean()`, *default:* `nil`) - Whether or not an entity was served from cache (with or without validation).\n*   `cacheLookup` (*type:* `boolean()`, *default:* `nil`) - Whether or not a cache lookup was attempted.\n*   `cacheValidatedWithOriginServer` (*type:* `boolean()`, *default:* `nil`) - Whether or not the response was validated with the origin server before being served from cache. This field is only meaningful if `cache_hit` is True.\n*   `latency` (*type:* `String.t`, *default:* `nil`) - The request processing latency on the server, from the time the request was received until the response was sent.\n*   `protocol` (*type:* `String.t`, *default:* `nil`) - Protocol used for the request. Examples: \"HTTP/1.1\", \"HTTP/2\", \"websocket\"\n*   `referer` (*type:* `String.t`, *default:* `nil`) - The referer URL of the request, as defined in [HTTP/1.1 Header Field Definitions](http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html).\n*   `remoteIp` (*type:* `String.t`, *default:* `nil`) - The IP address (IPv4 or IPv6) of the client that issued the HTTP request. Examples: `\"192.168.1.1\"`, `\"FE80::0202:B3FF:FE1E:8329\"`.\n*   `requestMethod` (*type:* `String.t`, *default:* `nil`) - The request method. Examples: `\"GET\"`, `\"HEAD\"`, `\"PUT\"`, `\"POST\"`.\n*   `requestSize` (*type:* `String.t`, *default:* `nil`) - The size of the HTTP request message in bytes, including the request headers and the request body.\n*   `requestUrl` (*type:* `String.t`, *default:* `nil`) - The scheme (http, https), the host name, the path, and the query portion of the URL that was requested. Example: `\"http://example.com/some/info?color=red\"`.\n*   `responseSize` (*type:* `String.t`, *default:* `nil`) - The size of the HTTP response message sent back to the client, in bytes, including the response headers and the response body.\n*   `serverIp` (*type:* `String.t`, *default:* `nil`) - The IP address (IPv4 or IPv6) of the origin server that the request was sent to.\n*   `status` (*type:* `integer()`, *default:* `nil`) - The response code indicating the status of the response. Examples: 200, 404.\n*   `userAgent` (*type:* `String.t`, *default:* `nil`) - The user agent sent by the client. Example: `\"Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; Q312461; .NET CLR 1.0.3705)\"`.","ref":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.V1HttpRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntry","doc":"An individual log entry.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntry.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.V1LogEntry","doc":"*   `httpRequest` (*type:* `GoogleApi.ServiceControl.V1.Model.V1HttpRequest.t`, *default:* `nil`) - Optional. Information about the HTTP request associated with this log entry, if applicable.\n*   `insertId` (*type:* `String.t`, *default:* `nil`) - A unique ID for the log entry used for deduplication. If omitted, the implementation will generate one based on operation_id.\n*   `labels` (*type:* `map()`, *default:* `nil`) - A set of user-defined (key, value) data that provides additional information about the log entry.\n*   `monitoredResourceLabels` (*type:* `map()`, *default:* `nil`) - A set of user-defined (key, value) data that provides additional information about the moniotored resource that the log entry belongs to.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The log to which this log entry belongs. Examples: `\"syslog\"`, `\"book_log\"`.\n*   `operation` (*type:* `GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.t`, *default:* `nil`) - Optional. Information about an operation associated with the log entry, if applicable.\n*   `protoPayload` (*type:* `map()`, *default:* `nil`) - The log entry payload, represented as a protocol buffer that is expressed as a JSON object. The only accepted type currently is AuditLog.\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of the log entry. The default value is `LogSeverity.DEFAULT`.\n*   `sourceLocation` (*type:* `GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.t`, *default:* `nil`) - Optional. Source code location information associated with the log entry, if any.\n*   `structPayload` (*type:* `map()`, *default:* `nil`) - The log entry payload, represented as a structure that is expressed as a JSON object.\n*   `textPayload` (*type:* `String.t`, *default:* `nil`) - The log entry payload, represented as a Unicode string (UTF-8).\n*   `timestamp` (*type:* `DateTime.t`, *default:* `nil`) - The time the event described by the log entry occurred. If omitted, defaults to operation start time.\n*   `trace` (*type:* `String.t`, *default:* `nil`) - Optional. Resource name of the trace associated with the log entry, if any. If this field contains a relative resource name, you can assume the name is relative to `//tracing.googleapis.com`. Example: `projects/my-projectid/traces/06796866738c859f2f19b7cfb3214824`","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntry.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntry.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntry.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntry.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntry.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation","doc":"Additional information about a potentially long-running operation with which a log entry is associated.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation","doc":"*   `first` (*type:* `boolean()`, *default:* `nil`) - Optional. Set this to True if this is the first log entry in the operation.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Optional. An arbitrary operation identifier. Log entries with the same identifier are assumed to be part of the same operation.\n*   `last` (*type:* `boolean()`, *default:* `nil`) - Optional. Set this to True if this is the last log entry in the operation.\n*   `producer` (*type:* `String.t`, *default:* `nil`) - Optional. An arbitrary producer identifier. The combination of `id` and `producer` must be globally unique. Examples for `producer`: `\"MyDivision.MyBigCompany.com\"`, `\"github.com/MyProject/MyApplication\"`.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntryOperation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation","doc":"Additional information about the source code location that produced the log entry.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation","doc":"*   `file` (*type:* `String.t`, *default:* `nil`) - Optional. Source file name. Depending on the runtime environment, this might be a simple name or a fully-qualified name.\n*   `function` (*type:* `String.t`, *default:* `nil`) - Optional. Human-readable name of the function or method being invoked, with optional context such as the class or package name. This information may be used in contexts such as the logs viewer, where a file and line number are less meaningful. The format can vary by language. For example: `qual.if.ied.Class.method` (Java), `dir/package.func` (Go), `function` (Python).\n*   `line` (*type:* `String.t`, *default:* `nil`) - Optional. Line within the source file. 1-based; 0 indicates no line number available.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.V1LogEntrySourceLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V1.Model.ViolationInfo","doc":"Provides information about the Policy violation info for this request.","ref":"GoogleApi.ServiceControl.V1.Model.ViolationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V1.Model.ViolationInfo","doc":"*   `checkedValue` (*type:* `String.t`, *default:* `nil`) - Optional. Value that is being checked for the policy. This could be in encrypted form (if pii sensitive). This field will only be emitted in LIST_POLICY types\n*   `constraint` (*type:* `String.t`, *default:* `nil`) - Optional. Constraint name\n*   `errorMessage` (*type:* `String.t`, *default:* `nil`) - Optional. Error message that policy is indicating.\n*   `policyType` (*type:* `String.t`, *default:* `nil`) - Optional. Indicates the type of the policy.","ref":"GoogleApi.ServiceControl.V1.Model.ViolationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V1.Model.ViolationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V1.Model.ViolationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V1.Model.ViolationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V1.Model.ViolationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2","doc":"API client metadata for GoogleApi.ServiceControl.V2.","ref":"GoogleApi.ServiceControl.V2.html"},{"type":"function","title":"GoogleApi.ServiceControl.V2.discovery_revision/0","doc":"","ref":"GoogleApi.ServiceControl.V2.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Api.Services","doc":"API calls for all endpoints tagged `Services`.","ref":"GoogleApi.ServiceControl.V2.Api.Services.html"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Api.Services.servicecontrol_services_check/4","doc":"Private Preview. This feature is only available for approved services. This method provides admission control for services that are integrated with [Service Infrastructure](https://cloud.google.com/service-infrastructure). It checks whether an operation should be allowed based on the service configuration and relevant policies. It must be called before the operation is executed. For more information, see [Admission Control](https://cloud.google.com/service-infrastructure/docs/admission-control). NOTE: The admission control has an expected policy propagation delay of 60s. The caller **must** not depend on the most recent policy changes. NOTE: The admission control has a hard limit of 1 referenced resources per call. If an operation refers to more than 1 resources, the caller must call the Check method multiple times. This method requires the `servicemanagement.services.check` permission on the specified service. For more information, see [Service Control API Access Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).","ref":"GoogleApi.ServiceControl.V2.Api.Services.html#servicecontrol_services_check/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V2.Api.Services.servicecontrol_services_check/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceControl.V2.Connection.t`) - Connection to server\n*   `service_name` (*type:* `String.t`) - The service name as specified in its service configuration. For example, `\"pubsub.googleapis.com\"`. See [google.api.Service](https://cloud.google.com/service-management/reference/rpc/google.api#google.api.Service) for the definition of a service name.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceControl.V2.Model.CheckRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceControl.V2.Api.Services.html#servicecontrol_services_check/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V2.Api.Services.servicecontrol_services_check/4","doc":"*   `{:ok, %GoogleApi.ServiceControl.V2.Model.CheckResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceControl.V2.Api.Services.html#servicecontrol_services_check/4-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Api.Services.servicecontrol_services_report/4","doc":"Private Preview. This feature is only available for approved services. This method provides telemetry reporting for services that are integrated with [Service Infrastructure](https://cloud.google.com/service-infrastructure). It reports a list of operations that have occurred on a service. It must be called after the operations have been executed. For more information, see [Telemetry Reporting](https://cloud.google.com/service-infrastructure/docs/telemetry-reporting). NOTE: The telemetry reporting has a hard limit of 1000 operations and 1MB per Report call. It is recommended to have no more than 100 operations per call. This method requires the `servicemanagement.services.report` permission on the specified service. For more information, see [Service Control API Access Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).","ref":"GoogleApi.ServiceControl.V2.Api.Services.html#servicecontrol_services_report/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V2.Api.Services.servicecontrol_services_report/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceControl.V2.Connection.t`) - Connection to server\n*   `service_name` (*type:* `String.t`) - The service name as specified in its service configuration. For example, `\"pubsub.googleapis.com\"`. See [google.api.Service](https://cloud.google.com/service-management/reference/rpc/google.api#google.api.Service) for the definition of a service name.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceControl.V2.Model.ReportRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceControl.V2.Api.Services.html#servicecontrol_services_report/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V2.Api.Services.servicecontrol_services_report/4","doc":"*   `{:ok, %GoogleApi.ServiceControl.V2.Model.ReportResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceControl.V2.Api.Services.html#servicecontrol_services_report/4-returns"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Connection","doc":"Handle Tesla connections for GoogleApi.ServiceControl.V2.","ref":"GoogleApi.ServiceControl.V2.Connection.html"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.ServiceControl.V2.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V2.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.ServiceControl.V2.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#get/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#head/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.ServiceControl.V2.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V2.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceControl.V2.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.ServiceControl.V2.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.ServiceControl.V2.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.ServiceControl.V2.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceControl.V2.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceControl.V2.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#options/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V2.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V2.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V2.Connection.html#post/4"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V2.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V2.Connection.html#put/4"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceControl.V2.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.ServiceControl.V2.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.ServiceControl.V2.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.ServiceControl.V2.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.ServiceControl.V2.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.ServiceControl.V2.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceControl.V2.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.ServiceControl.V2.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Connection.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Api","doc":"This message defines attributes associated with API operations, such as a network API request. The terminology is based on the conventions used by Google APIs, Istio, and OpenAPI.","ref":"GoogleApi.ServiceControl.V2.Model.Api.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Api","doc":"*   `operation` (*type:* `String.t`, *default:* `nil`) - The API operation name. For gRPC requests, it is the fully qualified API method name, such as \"google.pubsub.v1.Publisher.Publish\". For OpenAPI requests, it is the `operationId`, such as \"getPet\".\n*   `protocol` (*type:* `String.t`, *default:* `nil`) - The API protocol used for sending the request, such as \"http\", \"https\", \"grpc\", or \"internal\".\n*   `service` (*type:* `String.t`, *default:* `nil`) - The API service name. It is a logical identifier for a networked API, such as \"pubsub.googleapis.com\". The naming syntax depends on the API management system being used for handling the request.\n*   `version` (*type:* `String.t`, *default:* `nil`) - The API version associated with the API operation above, such as \"v1\" or \"v1alpha1\".","ref":"GoogleApi.ServiceControl.V2.Model.Api.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Api.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Api.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Api.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Api.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.AttributeContext","doc":"This message defines the standard attribute vocabulary for Google APIs. An attribute is a piece of metadata that describes an activity on a network service. For example, the size of an HTTP request, or the status code of an HTTP response. Each attribute has a type and a name, which is logically defined as a proto message field in `AttributeContext`. The field type becomes the attribute type, and the field path becomes the attribute name. For example, the attribute `source.ip` maps to field `AttributeContext.source.ip`. This message definition is guaranteed not to have any wire breaking change. So you can use it directly for passing attributes across different systems. NOTE: Different system may generate different subset of attributes. Please verify the system specification before relying on an attribute generated a system.","ref":"GoogleApi.ServiceControl.V2.Model.AttributeContext.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.AttributeContext","doc":"*   `api` (*type:* `GoogleApi.ServiceControl.V2.Model.Api.t`, *default:* `nil`) - Represents an API operation that is involved to a network activity.\n*   `destination` (*type:* `GoogleApi.ServiceControl.V2.Model.Peer.t`, *default:* `nil`) - The destination of a network activity, such as accepting a TCP connection. In a multi hop network activity, the destination represents the receiver of the last hop.\n*   `extensions` (*type:* `list(map())`, *default:* `nil`) - Supports extensions for advanced use cases, such as logs and metrics.\n*   `origin` (*type:* `GoogleApi.ServiceControl.V2.Model.Peer.t`, *default:* `nil`) - The origin of a network activity. In a multi hop network activity, the origin represents the sender of the first hop. For the first hop, the `source` and the `origin` must have the same content.\n*   `request` (*type:* `GoogleApi.ServiceControl.V2.Model.Request.t`, *default:* `nil`) - Represents a network request, such as an HTTP request.\n*   `resource` (*type:* `GoogleApi.ServiceControl.V2.Model.Resource.t`, *default:* `nil`) - Represents a target resource that is involved with a network activity. If multiple resources are involved with an activity, this must be the primary one.\n*   `response` (*type:* `GoogleApi.ServiceControl.V2.Model.Response.t`, *default:* `nil`) - Represents a network response, such as an HTTP response.\n*   `source` (*type:* `GoogleApi.ServiceControl.V2.Model.Peer.t`, *default:* `nil`) - The source of a network activity, such as starting a TCP connection. In a multi hop network activity, the source represents the sender of the last hop.","ref":"GoogleApi.ServiceControl.V2.Model.AttributeContext.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.AttributeContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.AttributeContext.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.AttributeContext.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.AttributeContext.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.AuditLog","doc":"Common audit log format for Google Cloud Platform API operations.","ref":"GoogleApi.ServiceControl.V2.Model.AuditLog.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.AuditLog","doc":"*   `authenticationInfo` (*type:* `GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.t`, *default:* `nil`) - Authentication information.\n*   `authorizationInfo` (*type:* `list(GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.t)`, *default:* `nil`) - Authorization information. If there are multiple resources or permissions involved, then there is one AuthorizationInfo element for each {resource, permission} tuple.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Other service-specific data about the request, response, and other information associated with the current audited event.\n*   `methodName` (*type:* `String.t`, *default:* `nil`) - The name of the service method or operation. For API calls, this should be the name of the API method. For example, \"google.cloud.bigquery.v2.TableService.InsertTable\" \"google.logging.v2.ConfigServiceV2.CreateSink\"\n*   `numResponseItems` (*type:* `String.t`, *default:* `nil`) - The number of items returned from a List or Query API method, if applicable.\n*   `policyViolationInfo` (*type:* `GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.t`, *default:* `nil`) - Indicates the policy violations for this request. If the request is denied by the policy, violation information will be logged here.\n*   `request` (*type:* `map()`, *default:* `nil`) - The operation request. This may not include all request parameters, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.\n*   `requestMetadata` (*type:* `GoogleApi.ServiceControl.V2.Model.RequestMetadata.t`, *default:* `nil`) - Metadata about the operation.\n*   `resourceLocation` (*type:* `GoogleApi.ServiceControl.V2.Model.ResourceLocation.t`, *default:* `nil`) - The resource location information.\n*   `resourceName` (*type:* `String.t`, *default:* `nil`) - The resource or collection that is the target of the operation. The name is a scheme-less URI, not including the API service name. For example: \"projects/PROJECT_ID/zones/us-central1-a/instances\" \"projects/PROJECT_ID/datasets/DATASET_ID\"\n*   `resourceOriginalState` (*type:* `map()`, *default:* `nil`) - The resource's original state before mutation. Present only for operations which have successfully modified the targeted resource(s). In general, this field should contain all changed fields, except those that are already been included in `request`, `response`, `metadata` or `service_data` fields. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.\n*   `response` (*type:* `map()`, *default:* `nil`) - The operation response. This may not include all response elements, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.\n*   `serviceData` (*type:* `map()`, *default:* `nil`) - Deprecated. Use the `metadata` field instead. Other service-specific data about the request, response, and other activities.\n*   `serviceName` (*type:* `String.t`, *default:* `nil`) - The name of the API service performing the operation. For example, `\"compute.googleapis.com\"`.\n*   `status` (*type:* `GoogleApi.ServiceControl.V2.Model.Status.t`, *default:* `nil`) - The status of the overall operation.","ref":"GoogleApi.ServiceControl.V2.Model.AuditLog.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.AuditLog.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.AuditLog.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.AuditLog.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.AuditLog.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Auth","doc":"This message defines request authentication attributes. Terminology is based on the JSON Web Token (JWT) standard, but the terms also correlate to concepts in other standards.","ref":"GoogleApi.ServiceControl.V2.Model.Auth.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Auth","doc":"*   `accessLevels` (*type:* `list(String.t)`, *default:* `nil`) - A list of access level resource names that allow resources to be accessed by authenticated requester. It is part of Secure GCP processing for the incoming request. An access level string has the format: \"//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}\" Example: \"//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL\"\n*   `audiences` (*type:* `list(String.t)`, *default:* `nil`) - The intended audience(s) for this authentication information. Reflects the audience (`aud`) claim within a JWT. The audience value(s) depends on the `issuer`, but typically include one or more of the following pieces of information: * The services intended to receive the credential. For example, [\"https://pubsub.googleapis.com/\", \"https://storage.googleapis.com/\"]. * A set of service-based scopes. For example, [\"https://www.googleapis.com/auth/cloud-platform\"]. * The client id of an app, such as the Firebase project id for JWTs from Firebase Auth. Consult the documentation for the credential issuer to determine the information provided.\n*   `claims` (*type:* `map()`, *default:* `nil`) - Structured claims presented with the credential. JWTs include `{key: value}` pairs for standard and private claims. The following is a subset of the standard required and optional claims that would typically be presented for a Google-based JWT: {'iss': 'accounts.google.com', 'sub': '113289723416554971153', 'aud': ['123456789012', 'pubsub.googleapis.com'], 'azp': '123456789012.apps.googleusercontent.com', 'email': 'jsmith@example.com', 'iat': 1353601026, 'exp': 1353604926} SAML assertions are similarly specified, but with an identity provider dependent structure.\n*   `presenter` (*type:* `String.t`, *default:* `nil`) - The authorized presenter of the credential. Reflects the optional Authorized Presenter (`azp`) claim within a JWT or the OAuth client id. For example, a Google Cloud Platform client id looks as follows: \"123456789012.apps.googleusercontent.com\".\n*   `principal` (*type:* `String.t`, *default:* `nil`) - The authenticated principal. Reflects the issuer (`iss`) and subject (`sub`) claims within a JWT. The issuer and subject should be `/` delimited, with `/` percent-encoded within the subject fragment. For Google accounts, the principal format is: \"https://accounts.google.com/{id}\"","ref":"GoogleApi.ServiceControl.V2.Model.Auth.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Auth.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Auth.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Auth.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Auth.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo","doc":"Authentication information for the operation.","ref":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.AuthenticationInfo","doc":"*   `authoritySelector` (*type:* `String.t`, *default:* `nil`) - The authority selector specified by the requestor, if any. It is not guaranteed that the principal was allowed to use this authority.\n*   `principalEmail` (*type:* `String.t`, *default:* `nil`) - The email address of the authenticated user (or service account on behalf of third party principal) making the request. For third party identity callers, the `principal_subject` field is populated instead of this field. For privacy reasons, the principal email address is sometimes redacted. For more information, see [Caller identities in audit logs](https://cloud.google.com/logging/docs/audit#user-id).\n*   `principalSubject` (*type:* `String.t`, *default:* `nil`) - String representation of identity of requesting party. Populated for both first and third party identities.\n*   `serviceAccountDelegationInfo` (*type:* `list(GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.t)`, *default:* `nil`) - Identity delegation history of an authenticated service account that makes the request. It contains information on the real authorities that try to access GCP resources by delegating on a service account. When multiple authorities present, they are guaranteed to be sorted based on the original ordering of the identity delegation events.\n*   `serviceAccountKeyName` (*type:* `String.t`, *default:* `nil`) - The name of the service account key used to create or exchange credentials for authenticating the service account making the request. This is a scheme-less URI full resource name. For example: \"//iam.googleapis.com/projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}\"\n*   `serviceDelegationHistory` (*type:* `GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.t`, *default:* `nil`) - Records the history of delegated resource access across Google services.\n*   `thirdPartyPrincipal` (*type:* `map()`, *default:* `nil`) - The third party identification (if any) of the authenticated user making the request. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the `@type` property.","ref":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.AuthenticationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo","doc":"Authorization information for the operation.","ref":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.AuthorizationInfo","doc":"*   `granted` (*type:* `boolean()`, *default:* `nil`) - Whether or not authorization for `resource` and `permission` was granted.\n*   `permission` (*type:* `String.t`, *default:* `nil`) - The required IAM permission.\n*   `resource` (*type:* `String.t`, *default:* `nil`) - The resource being accessed, as a REST-style or cloud resource string. For example: bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID or projects/PROJECTID/datasets/DATASETID\n*   `resourceAttributes` (*type:* `GoogleApi.ServiceControl.V2.Model.Resource.t`, *default:* `nil`) - Resource attributes used in IAM condition evaluation. This field contains resource attributes like resource type and resource name. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into `AuditLog.request_metadata.request_attributes`.","ref":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.AuthorizationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.CheckRequest","doc":"Request message for the Check method.","ref":"GoogleApi.ServiceControl.V2.Model.CheckRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.CheckRequest","doc":"*   `attributes` (*type:* `GoogleApi.ServiceControl.V2.Model.AttributeContext.t`, *default:* `nil`) - Describes attributes about the operation being executed by the service.\n*   `flags` (*type:* `String.t`, *default:* `nil`) - Optional. Contains a comma-separated list of flags.\n*   `resources` (*type:* `list(GoogleApi.ServiceControl.V2.Model.ResourceInfo.t)`, *default:* `nil`) - Describes the resources and the policies applied to each resource.\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - Specifies the version of the service configuration that should be used to process the request. Must not be empty. Set this field to 'latest' to specify using the latest configuration.","ref":"GoogleApi.ServiceControl.V2.Model.CheckRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.CheckRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.CheckRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.CheckRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.CheckRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.CheckResponse","doc":"Response message for the Check method.","ref":"GoogleApi.ServiceControl.V2.Model.CheckResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.CheckResponse","doc":"*   `headers` (*type:* `map()`, *default:* `nil`) - Returns a set of request contexts generated from the `CheckRequest`.\n*   `status` (*type:* `GoogleApi.ServiceControl.V2.Model.Status.t`, *default:* `nil`) - Operation is allowed when this field is not set. Any non-'OK' status indicates a denial; google.rpc.Status.details would contain additional details about the denial.","ref":"GoogleApi.ServiceControl.V2.Model.CheckResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.CheckResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.CheckResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.CheckResponse.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.CheckResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal","doc":"First party identity principal.","ref":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal","doc":"*   `principalEmail` (*type:* `String.t`, *default:* `nil`) - The email address of a Google account. .\n*   `serviceMetadata` (*type:* `map()`, *default:* `nil`) - Metadata about the service that uses the service account. .","ref":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo","doc":"Represents OrgPolicy Violation information.","ref":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo","doc":"*   `payload` (*type:* `map()`, *default:* `nil`) - Optional. Resource payload that is currently in scope and is subjected to orgpolicy conditions. This payload may be the subset of the actual Resource that may come in the request. This payload should not contain any core content.\n*   `resourceTags` (*type:* `map()`, *default:* `nil`) - Optional. Tags referenced on the resource at the time of evaluation. These also include the federated tags, if they are supplied in the CheckOrgPolicy or CheckCustomConstraints Requests. Optional field as of now. These tags are the Cloud tags that are available on the resource during the policy evaluation and will be available as part of the OrgPolicy check response for logging purposes.\n*   `resourceType` (*type:* `String.t`, *default:* `nil`) - Optional. Resource type that the orgpolicy is checked against. Example: compute.googleapis.com/Instance, store.googleapis.com/bucket\n*   `violationInfo` (*type:* `list(GoogleApi.ServiceControl.V2.Model.ViolationInfo.t)`, *default:* `nil`) - Optional. Policy violations","ref":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Peer","doc":"This message defines attributes for a node that handles a network request. The node can be either a service or an application that sends, forwards, or receives the request. Service peers should fill in `principal` and `labels` as appropriate.","ref":"GoogleApi.ServiceControl.V2.Model.Peer.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Peer","doc":"*   `ip` (*type:* `String.t`, *default:* `nil`) - The IP address of the peer.\n*   `labels` (*type:* `map()`, *default:* `nil`) - The labels associated with the peer.\n*   `port` (*type:* `String.t`, *default:* `nil`) - The network port of the peer.\n*   `principal` (*type:* `String.t`, *default:* `nil`) - The identity of this peer. Similar to `Request.auth.principal`, but relative to the peer instead of the request. For example, the identity associated with a load balancer that forwarded the request.\n*   `regionCode` (*type:* `String.t`, *default:* `nil`) - The CLDR country/region code associated with the above IP address. If the IP address is private, the `region_code` should reflect the physical location where this peer is running.","ref":"GoogleApi.ServiceControl.V2.Model.Peer.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Peer.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Peer.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Peer.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Peer.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo","doc":"Information related to policy violations for this request.","ref":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo","doc":"*   `orgPolicyViolationInfo` (*type:* `GoogleApi.ServiceControl.V2.Model.OrgPolicyViolationInfo.t`, *default:* `nil`) - Indicates the orgpolicy violations for this resource.","ref":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.PolicyViolationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ReportRequest","doc":"Request message for the Report method.","ref":"GoogleApi.ServiceControl.V2.Model.ReportRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ReportRequest","doc":"*   `operations` (*type:* `list(GoogleApi.ServiceControl.V2.Model.AttributeContext.t)`, *default:* `nil`) - Describes the list of operations to be reported. Each operation is represented as an AttributeContext, and contains all attributes around an API access.\n*   `serviceConfigId` (*type:* `String.t`, *default:* `nil`) - Specifies the version of the service configuration that should be used to process the request. Must not be empty. Set this field to 'latest' to specify using the latest configuration.","ref":"GoogleApi.ServiceControl.V2.Model.ReportRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ReportRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ReportRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ReportRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ReportRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ReportResponse","doc":"Response message for the Report method.","ref":"GoogleApi.ServiceControl.V2.Model.ReportResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ReportResponse","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ReportResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ReportResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ReportResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ReportResponse.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ReportResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Request","doc":"This message defines attributes for an HTTP request. If the actual request is not an HTTP request, the runtime system should try to map the actual request to an equivalent HTTP request.","ref":"GoogleApi.ServiceControl.V2.Model.Request.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Request","doc":"*   `auth` (*type:* `GoogleApi.ServiceControl.V2.Model.Auth.t`, *default:* `nil`) - The request authentication. May be absent for unauthenticated requests. Derived from the HTTP request `Authorization` header or equivalent.\n*   `headers` (*type:* `map()`, *default:* `nil`) - The HTTP request headers. If multiple headers share the same key, they must be merged according to the HTTP spec. All header keys must be lowercased, because HTTP header keys are case-insensitive.\n*   `host` (*type:* `String.t`, *default:* `nil`) - The HTTP request `Host` header value.\n*   `id` (*type:* `String.t`, *default:* `nil`) - The unique ID for a request, which can be propagated to downstream systems. The ID should have low probability of collision within a single day for a specific service.\n*   `method` (*type:* `String.t`, *default:* `nil`) - The HTTP request method, such as `GET`, `POST`.\n*   `path` (*type:* `String.t`, *default:* `nil`) - The HTTP URL path, excluding the query parameters.\n*   `protocol` (*type:* `String.t`, *default:* `nil`) - The network protocol used with the request, such as \"http/1.1\", \"spdy/3\", \"h2\", \"h2c\", \"webrtc\", \"tcp\", \"udp\", \"quic\". See https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids for details.\n*   `query` (*type:* `String.t`, *default:* `nil`) - The HTTP URL query in the format of `name1=value1&name2=value2`, as it appears in the first line of the HTTP request. No decoding is performed.\n*   `reason` (*type:* `String.t`, *default:* `nil`) - A special parameter for request reason. It is used by security systems to associate auditing information with a request.\n*   `scheme` (*type:* `String.t`, *default:* `nil`) - The HTTP URL scheme, such as `http` and `https`.\n*   `size` (*type:* `String.t`, *default:* `nil`) - The HTTP request size in bytes. If unknown, it must be -1.\n*   `time` (*type:* `DateTime.t`, *default:* `nil`) - The timestamp when the `destination` service receives the last byte of the request.","ref":"GoogleApi.ServiceControl.V2.Model.Request.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Request.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Request.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Request.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Request.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.RequestMetadata","doc":"Metadata about the request.","ref":"GoogleApi.ServiceControl.V2.Model.RequestMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.RequestMetadata","doc":"*   `callerIp` (*type:* `String.t`, *default:* `nil`) - The IP address of the caller. For a caller from the internet, this will be the public IPv4 or IPv6 address. For calls made from inside Google's internal production network from one GCP service to another, `caller_ip` will be redacted to \"private\". For a caller from a Compute Engine VM with a external IP address, `caller_ip` will be the VM's external IP address. For a caller from a Compute Engine VM without a external IP address, if the VM is in the same organization (or project) as the accessed resource, `caller_ip` will be the VM's internal IPv4 address, otherwise `caller_ip` will be redacted to \"gce-internal-ip\". See https://cloud.google.com/compute/docs/vpc/ for more information.\n*   `callerNetwork` (*type:* `String.t`, *default:* `nil`) - The network of the caller. Set only if the network host project is part of the same GCP organization (or project) as the accessed resource. See https://cloud.google.com/compute/docs/vpc/ for more information. This is a scheme-less URI full resource name. For example: \"//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID\"\n*   `callerSuppliedUserAgent` (*type:* `String.t`, *default:* `nil`) - The user agent of the caller. This information is not authenticated and should be treated accordingly. For example: + `google-api-python-client/1.4.0`: The request was made by the Google API client for Python. + `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`: The request was made by the Google Cloud SDK CLI (gcloud). + `AppEngine-Google; (+http://code.google.com/appengine; appid: s~my-project`: The request was made from the `my-project` App Engine app.\n*   `destinationAttributes` (*type:* `GoogleApi.ServiceControl.V2.Model.Peer.t`, *default:* `nil`) - The destination of a network activity, such as accepting a TCP connection. In a multi hop network activity, the destination represents the receiver of the last hop. Only two fields are used in this message, Peer.port and Peer.ip. These fields are optionally populated by those services utilizing the IAM condition feature.\n*   `requestAttributes` (*type:* `GoogleApi.ServiceControl.V2.Model.Request.t`, *default:* `nil`) - Request attributes used in IAM condition evaluation. This field contains request attributes like request time and access levels associated with the request. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into `AuditLog.authentication_info.resource_attributes`.","ref":"GoogleApi.ServiceControl.V2.Model.RequestMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.RequestMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.RequestMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.RequestMetadata.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.RequestMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Resource","doc":"This message defines core attributes for a resource. A resource is an addressable (named) entity provided by the destination service. For example, a file stored on a network storage service.","ref":"GoogleApi.ServiceControl.V2.Model.Resource.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Resource","doc":"*   `annotations` (*type:* `map()`, *default:* `nil`) - Annotations is an unstructured key-value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations/\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the resource was created. This may be either the time creation was initiated or when it was completed.\n*   `deleteTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the resource was deleted. If the resource is not deleted, this must be empty.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - Mutable. The display name set by clients. Must be <= 63 characters.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - Output only. An opaque value that uniquely identifies a version or generation of a resource. It can be used to confirm that the client and server agree on the ordering of a resource being written.\n*   `labels` (*type:* `map()`, *default:* `nil`) - The labels or tags on the resource, such as AWS resource tags and Kubernetes resource labels.\n*   `location` (*type:* `String.t`, *default:* `nil`) - Immutable. The location of the resource. The location encoding is specific to the service provider, and new encoding may be introduced as the service evolves. For Google Cloud products, the encoding is what is used by Google Cloud APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The semantics of `location` is identical to the `cloud.googleapis.com/location` label used by some Google Cloud APIs.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The stable identifier (name) of a resource on the `service`. A resource can be logically identified as \"//{resource.service}/{resource.name}\". The differences between a resource name and a URI are: * Resource name is a logical identifier, independent of network protocol and API version. For example, `//pubsub.googleapis.com/projects/123/topics/news-feed`. * URI often includes protocol and version information, so it can be used directly by applications. For example, `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`. See https://cloud.google.com/apis/design/resource_names for details.\n*   `service` (*type:* `String.t`, *default:* `nil`) - The name of the service that this resource belongs to, such as `pubsub.googleapis.com`. The service may be different from the DNS hostname that actually serves the request.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of the resource. The syntax is platform-specific because different platforms define their resources differently. For Google APIs, the type format must be \"{service}/{kind}\", such as \"pubsub.googleapis.com/Topic\".\n*   `uid` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the resource. UID is unique in the time and space for this resource within the scope of the service. It is typically generated by the server on successful creation of a resource and must not be changed. UID is used to uniquely identify resources with resource name reuses. This should be a UUID4.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the resource was last updated. Any change to the resource made by users must refresh this value. Changes to a resource made by the service should refresh this value.","ref":"GoogleApi.ServiceControl.V2.Model.Resource.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Resource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Resource.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Resource.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Resource.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ResourceInfo","doc":"Describes a resource referenced in the request.","ref":"GoogleApi.ServiceControl.V2.Model.ResourceInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ResourceInfo","doc":"*   `container` (*type:* `String.t`, *default:* `nil`) - Optional. The identifier of the container of this resource. For Google Cloud APIs, the resource container must be one of the following formats: - `projects/` - `folders/` - `organizations/` Required for the policy enforcement on the container level (e.g. VPCSC, Location Policy check, Org Policy check).\n*   `location` (*type:* `String.t`, *default:* `nil`) - Optional. The location of the resource, it must be a valid zone, region or multiregion, for example: \"europe-west4\", \"northamerica-northeast1-a\". Required for location policy check.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the resource referenced in the request.\n*   `permission` (*type:* `String.t`, *default:* `nil`) - The resource permission needed for this request. The format must be \"{service}/{plural}.{verb}\".\n*   `type` (*type:* `String.t`, *default:* `nil`) - The resource type in the format of \"{service}/{kind}\".","ref":"GoogleApi.ServiceControl.V2.Model.ResourceInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ResourceInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ResourceInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ResourceInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ResourceInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ResourceLocation","doc":"Location information about a resource.","ref":"GoogleApi.ServiceControl.V2.Model.ResourceLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ResourceLocation","doc":"*   `currentLocations` (*type:* `list(String.t)`, *default:* `nil`) - The locations of a resource after the execution of the operation. Requests to create or delete a location based resource must populate the 'current_locations' field and not the 'original_locations' field. For example: \"europe-west1-a\" \"us-east1\" \"nam3\"\n*   `originalLocations` (*type:* `list(String.t)`, *default:* `nil`) - The locations of a resource prior to the execution of the operation. Requests that mutate the resource's location must populate both the 'original_locations' as well as the 'current_locations' fields. For example: \"europe-west1-a\" \"us-east1\" \"nam3\"","ref":"GoogleApi.ServiceControl.V2.Model.ResourceLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ResourceLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ResourceLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ResourceLocation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ResourceLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Response","doc":"This message defines attributes for a typical network response. It generally models semantics of an HTTP response.","ref":"GoogleApi.ServiceControl.V2.Model.Response.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Response","doc":"*   `backendLatency` (*type:* `String.t`, *default:* `nil`) - The amount of time it takes the backend service to fully respond to a request. Measured from when the destination service starts to send the request to the backend until when the destination service receives the complete response from the backend.\n*   `code` (*type:* `String.t`, *default:* `nil`) - The HTTP response status code, such as `200` and `404`.\n*   `headers` (*type:* `map()`, *default:* `nil`) - The HTTP response headers. If multiple headers share the same key, they must be merged according to HTTP spec. All header keys must be lowercased, because HTTP header keys are case-insensitive.\n*   `size` (*type:* `String.t`, *default:* `nil`) - The HTTP response size in bytes. If unknown, it must be -1.\n*   `time` (*type:* `DateTime.t`, *default:* `nil`) - The timestamp when the `destination` service sends the last byte of the response.","ref":"GoogleApi.ServiceControl.V2.Model.Response.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Response.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Response.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Response.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Response.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo","doc":"Identity delegation history of an authenticated service account.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo","doc":"*   `firstPartyPrincipal` (*type:* `GoogleApi.ServiceControl.V2.Model.FirstPartyPrincipal.t`, *default:* `nil`) - First party (Google) identity as the real authority.\n*   `principalSubject` (*type:* `String.t`, *default:* `nil`) - A string representing the principal_subject associated with the identity. For most identities, the format will be `principal://iam.googleapis.com/{identity pool name}/subject/{subject)` except for some GKE identities (GKE_WORKLOAD, FREEFORM, GKE_HUB_WORKLOAD) that are still in the legacy format `serviceAccount:{identity pool name}[{subject}]`\n*   `thirdPartyPrincipal` (*type:* `GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.t`, *default:* `nil`) - Third party identity as the real authority.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ServiceAccountDelegationInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory","doc":"The history of delegation across multiple services as the result of the original user's action. Such as \"service A uses its own account to do something for user B\". This differs from ServiceAccountDelegationInfo, which only tracks the history of direct token exchanges (impersonation).","ref":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory","doc":"*   `originalPrincipal` (*type:* `String.t`, *default:* `nil`) - The original end user who initiated the request to GCP.\n*   `serviceMetadata` (*type:* `list(GoogleApi.ServiceControl.V2.Model.ServiceMetadata.t)`, *default:* `nil`) - Data identifying the service specific jobs or units of work that were involved in a chain of service calls.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ServiceDelegationHistory.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata","doc":"Metadata describing the service and additional service specific information used to identify the job or unit of work at hand.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ServiceMetadata","doc":"*   `jobMetadata` (*type:* `map()`, *default:* `nil`) - Additional metadata provided by service teams to describe service specific job information that was triggered by the original principal.\n*   `principalSubject` (*type:* `String.t`, *default:* `nil`) - A string representing the principal_subject associated with the identity. For most identities, the format will be `principal://iam.googleapis.com/{identity pool name}/subject/{subject)` except for some GKE identities (GKE_WORKLOAD, FREEFORM, GKE_HUB_WORKLOAD) that are still in the legacy format `serviceAccount:{identity pool name}[{subject}]` If the identity is a Google account (e.g. workspace user account or service account), this will be the email of the prefixed by `serviceAccount:`. For example: `serviceAccount:my-service-account@project-1.iam.gserviceaccount.com`. If the identity is an individual user, the identity will be formatted as: `user:user_ABC@email.com`.\n*   `serviceDomain` (*type:* `String.t`, *default:* `nil`) - The service's fully qualified domain name, e.g. \"dataproc.googleapis.com\".","ref":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ServiceMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.SpanContext","doc":"The context of a span. This is attached to an Exemplar in Distribution values during aggregation. It contains the name of a span with format: projects/[PROJECT_ID_OR_NUMBER]/traces/[TRACE_ID]/spans/[SPAN_ID]","ref":"GoogleApi.ServiceControl.V2.Model.SpanContext.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.SpanContext","doc":"*   `spanName` (*type:* `String.t`, *default:* `nil`) - The resource name of the span. The format is: projects/[PROJECT_ID_OR_NUMBER]/traces/[TRACE_ID]/spans/[SPAN_ID] `[TRACE_ID]` is a unique identifier for a trace within a project; it is a 32-character hexadecimal encoding of a 16-byte array. `[SPAN_ID]` is a unique identifier for a span within a trace; it is a 16-character hexadecimal encoding of an 8-byte array.","ref":"GoogleApi.ServiceControl.V2.Model.SpanContext.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.SpanContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.SpanContext.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.SpanContext.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.SpanContext.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.Status","doc":"The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).","ref":"GoogleApi.ServiceControl.V2.Model.Status.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.Status","doc":"*   `code` (*type:* `integer()`, *default:* `nil`) - The status code, which should be an enum value of google.rpc.Code.\n*   `details` (*type:* `list(map())`, *default:* `nil`) - A list of messages that carry the error details. There is a common set of message types for APIs to use.\n*   `message` (*type:* `String.t`, *default:* `nil`) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.","ref":"GoogleApi.ServiceControl.V2.Model.Status.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.Status.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.Status.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.Status.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.Status.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal","doc":"Third party identity principal.","ref":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal","doc":"*   `thirdPartyClaims` (*type:* `map()`, *default:* `nil`) - Metadata about third party identity.","ref":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ThirdPartyPrincipal.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest","doc":"A common proto for logging HTTP requests. Only contains semantics defined by the HTTP specification. Product-specific logging information MUST be defined in a separate message.","ref":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.V2HttpRequest","doc":"*   `cacheFillBytes` (*type:* `String.t`, *default:* `nil`) - The number of HTTP response bytes inserted into cache. Set only when a cache fill was attempted.\n*   `cacheHit` (*type:* `boolean()`, *default:* `nil`) - Whether or not an entity was served from cache (with or without validation).\n*   `cacheLookup` (*type:* `boolean()`, *default:* `nil`) - Whether or not a cache lookup was attempted.\n*   `cacheValidatedWithOriginServer` (*type:* `boolean()`, *default:* `nil`) - Whether or not the response was validated with the origin server before being served from cache. This field is only meaningful if `cache_hit` is True.\n*   `latency` (*type:* `String.t`, *default:* `nil`) - The request processing latency on the server, from the time the request was received until the response was sent.\n*   `protocol` (*type:* `String.t`, *default:* `nil`) - Protocol used for the request. Examples: \"HTTP/1.1\", \"HTTP/2\", \"websocket\"\n*   `referer` (*type:* `String.t`, *default:* `nil`) - The referer URL of the request, as defined in [HTTP/1.1 Header Field Definitions](http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html).\n*   `remoteIp` (*type:* `String.t`, *default:* `nil`) - The IP address (IPv4 or IPv6) of the client that issued the HTTP request. Examples: `\"192.168.1.1\"`, `\"FE80::0202:B3FF:FE1E:8329\"`.\n*   `requestMethod` (*type:* `String.t`, *default:* `nil`) - The request method. Examples: `\"GET\"`, `\"HEAD\"`, `\"PUT\"`, `\"POST\"`.\n*   `requestSize` (*type:* `String.t`, *default:* `nil`) - The size of the HTTP request message in bytes, including the request headers and the request body.\n*   `requestUrl` (*type:* `String.t`, *default:* `nil`) - The scheme (http, https), the host name, the path, and the query portion of the URL that was requested. Example: `\"http://example.com/some/info?color=red\"`.\n*   `responseSize` (*type:* `String.t`, *default:* `nil`) - The size of the HTTP response message sent back to the client, in bytes, including the response headers and the response body.\n*   `serverIp` (*type:* `String.t`, *default:* `nil`) - The IP address (IPv4 or IPv6) of the origin server that the request was sent to.\n*   `status` (*type:* `integer()`, *default:* `nil`) - The response code indicating the status of the response. Examples: 200, 404.\n*   `userAgent` (*type:* `String.t`, *default:* `nil`) - The user agent sent by the client. Example: `\"Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; Q312461; .NET CLR 1.0.3705)\"`.","ref":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.V2HttpRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntry","doc":"An individual log entry.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntry.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.V2LogEntry","doc":"*   `httpRequest` (*type:* `GoogleApi.ServiceControl.V2.Model.V2HttpRequest.t`, *default:* `nil`) - Optional. Information about the HTTP request associated with this log entry, if applicable.\n*   `insertId` (*type:* `String.t`, *default:* `nil`) - A unique ID for the log entry used for deduplication. If omitted, the implementation will generate one based on operation_id.\n*   `labels` (*type:* `map()`, *default:* `nil`) - A set of user-defined (key, value) data that provides additional information about the log entry.\n*   `monitoredResourceLabels` (*type:* `map()`, *default:* `nil`) - A set of user-defined (key, value) data that provides additional information about the moniotored resource that the log entry belongs to.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The log to which this log entry belongs. Examples: `\"syslog\"`, `\"book_log\"`.\n*   `operation` (*type:* `GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.t`, *default:* `nil`) - Optional. Information about an operation associated with the log entry, if applicable.\n*   `protoPayload` (*type:* `map()`, *default:* `nil`) - The log entry payload, represented as a protocol buffer that is expressed as a JSON object. The only accepted type currently is AuditLog.\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of the log entry. The default value is `LogSeverity.DEFAULT`.\n*   `sourceLocation` (*type:* `GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.t`, *default:* `nil`) - Optional. Source code location information associated with the log entry, if any.\n*   `structPayload` (*type:* `map()`, *default:* `nil`) - The log entry payload, represented as a structure that is expressed as a JSON object.\n*   `textPayload` (*type:* `String.t`, *default:* `nil`) - The log entry payload, represented as a Unicode string (UTF-8).\n*   `timestamp` (*type:* `DateTime.t`, *default:* `nil`) - The time the event described by the log entry occurred. If omitted, defaults to operation start time.\n*   `trace` (*type:* `String.t`, *default:* `nil`) - Optional. Resource name of the trace associated with the log entry, if any. If this field contains a relative resource name, you can assume the name is relative to `//tracing.googleapis.com`. Example: `projects/my-projectid/traces/06796866738c859f2f19b7cfb3214824`","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntry.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntry.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntry.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntry.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntry.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation","doc":"Additional information about a potentially long-running operation with which a log entry is associated.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation","doc":"*   `first` (*type:* `boolean()`, *default:* `nil`) - Optional. Set this to True if this is the first log entry in the operation.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Optional. An arbitrary operation identifier. Log entries with the same identifier are assumed to be part of the same operation.\n*   `last` (*type:* `boolean()`, *default:* `nil`) - Optional. Set this to True if this is the last log entry in the operation.\n*   `producer` (*type:* `String.t`, *default:* `nil`) - Optional. An arbitrary producer identifier. The combination of `id` and `producer` must be globally unique. Examples for `producer`: `\"MyDivision.MyBigCompany.com\"`, `\"github.com/MyProject/MyApplication\"`.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntryOperation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation","doc":"Additional information about the source code location that produced the log entry.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation","doc":"*   `file` (*type:* `String.t`, *default:* `nil`) - Optional. Source file name. Depending on the runtime environment, this might be a simple name or a fully-qualified name.\n*   `function` (*type:* `String.t`, *default:* `nil`) - Optional. Human-readable name of the function or method being invoked, with optional context such as the class or package name. This information may be used in contexts such as the logs viewer, where a file and line number are less meaningful. The format can vary by language. For example: `qual.if.ied.Class.method` (Java), `dir/package.func` (Go), `function` (Python).\n*   `line` (*type:* `String.t`, *default:* `nil`) - Optional. Line within the source file. 1-based; 0 indicates no line number available.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.V2LogEntrySourceLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceControl.V2.Model.ViolationInfo","doc":"Provides information about the Policy violation info for this request.","ref":"GoogleApi.ServiceControl.V2.Model.ViolationInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceControl.V2.Model.ViolationInfo","doc":"*   `checkedValue` (*type:* `String.t`, *default:* `nil`) - Optional. Value that is being checked for the policy. This could be in encrypted form (if pii sensitive). This field will only be emitted in LIST_POLICY types\n*   `constraint` (*type:* `String.t`, *default:* `nil`) - Optional. Constraint name\n*   `errorMessage` (*type:* `String.t`, *default:* `nil`) - Optional. Error message that policy is indicating.\n*   `policyType` (*type:* `String.t`, *default:* `nil`) - Optional. Indicates the type of the policy.","ref":"GoogleApi.ServiceControl.V2.Model.ViolationInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceControl.V2.Model.ViolationInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceControl.V2.Model.ViolationInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceControl.V2.Model.ViolationInfo.t/0","doc":"","ref":"GoogleApi.ServiceControl.V2.Model.ViolationInfo.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}